#include "copyright.h"
#include "port.h"
#include "utility.h"
#include "options.h"
#include "oct.h"
#include "oh.h"
#include "st.h"
#include "errtrap.h"
#include "io.h"
#include "internal.h"
#include "edit.h"

/* This flag is necessary to allow inspectFacet to be callable from 
 * the attache executable or from another program that attache has been
 * linked into.  */
extern attacheCalledFromMainP;

optionStruct optionList[] = {
    { OPT_RARG,	"cell:view[:facet]",
	    "the oct facet to be edited (defaults to contents facet)"	},
    { 0,	0,	0						}
};

main(argc, argv)
int argc;
char *argv[];
{
    int option;
    octObject facet;
    struct state outerState;
    SIGNAL_FN die();


    while ((option = optGetOption(argc, argv)) != EOF) {
	switch (option) {
	}
    }

    if (optind != argc-1) optUsage();

    ohUnpackDefaults(&facet, "r", "::contents");
    if (ohUnpackFacetName(&facet, argv[optind]) != OCT_OK) {
	optUsage();
    }

    nameTable = st_init_table(strcmp, st_strhash);
    outerState.genMask = OCT_ALL_MASK;
    currentState = &outerState;
    attacheCalledFromMainP = 1;

    (void) signal(SIGINT, die);

    inspectFacet(&facet);

    octEnd();

    exit(RET_OK);
}




SIGNAL_FN die()
{
    IOend();
    (void) printf("Interrupt -- really kill program? ");
    if (getchar() == 'y') exit(RET_FAIL);

    while(getchar() != '\n');
    IOinit();
    errRaise(optProgName, 0, "return from interrupt");
}




