#include "copyright.h"
#include "port.h"
#include "utility.h"
#include "oct.h"
#include "oh.h"
#include "st.h"
#include "errtrap.h"
#include "io.h"
#include "internal.h"
#include "obj.h"

updateScreen()
{
    octGenerator gen;
    octStatus status;
    octObject obj;
    int i;

    IOclearScreen();

    updateHeader(&currentState->currentObject);

    if (currentState->genDirection == CONTENTS) {
	OCT_ASSERT(octInitGenContents(&currentState->currentObject,
				    currentState->genMask, &gen), "%s");
    } else {
	OCT_ASSERT(octInitGenContainers(&currentState->currentObject,
				    currentState->genMask, &gen), "%s");
    }

    if (currentState->genPos < 1) currentState->genPos = 1;
    for (i = 0; i < currentState->genPos; i++) {
	if ((status = octGenerate(&gen, &obj)) != OCT_OK) break;
    }
    OCT_ASSERT(status, "%s");
    if (i == 0) return;
    currentState->genPos = i;
    for (i = 0; i < nObjs; i++) {
	printObjectSummary(&obj);
	IOputchar('\n');
        if ((status = octGenerate(&gen, &obj)) != OCT_OK) break;
    }
    OCT_ASSERT(status, "%s");
}

updateHeader(objPtr)
octObject *objPtr;
{
    struct maskEntry *mePtr;

    IOhome();
    IOclearLine();
    IOputs(currentState->currentFacet.contents.facet.cell);
    IOputchar(':');
    IOputs(currentState->currentFacet.contents.facet.view);
    IOputchar(':');
    IOputs(currentState->currentFacet.contents.facet.facet);
    IOmove(0, COLS-20);
    IOputs(currentState->genDirection == CONTENTS ?
		    "Contents   " :
		    "Containers ");
    for (mePtr = maskTable; mePtr->mask != 0; mePtr++) {
	if ((currentState->genMask & mePtr->mask) == mePtr->mask) {
	    IOputchar(toupper(mePtr->codeChar));
	} else {
	    IOputchar(mePtr->codeChar);
	}
    }
    IOputs("\n\n");
    IOstandout();
    printObjectSummary(objPtr);
    IOstandend();
    IOputchar('\n');
}

printObjectSummary(objPtr)
octObject *objPtr;
{
    if (objPtr == NIL(octObject)) return;

    printTemplate(summaryTemplate, objPtr);
}

PROMPT(str)
char *str;
{
    quitAll = 0;
    IObotHome();
    IOclearLine();
    IOputs(str);
    IOputchar(' ');
    IOrefresh();
}
