#define MAXVARS 20

typedef struct term_struct term;
struct term_struct {
    int coef;
    short vars[MAXVARS];
    term *next;
};


/* struct to hold polynomial for a const */
typedef struct cexpr_struct cexpr;
struct cexpr_struct {
    term *value;
    int width;
    cexpr *next;
};


/*
 * EXPR is an expression of consts and parameters (value in union)
 * ID is either a bus or terminal (name in union);
 * INTERN is an internally declared net, (id in union)
 */
enum ident_type {EXPR, ID, INTERN};
typedef struct ident_struct ident;      /* const_identifier */
struct ident_struct {
    enum ident_type type;
    union {
	char *name;
	term *value;			/* holds the constant */
	long net;			/* holds octId of net */
    } u;
    term *hbit, *lbit;
    ident *next;
};

/* routines of alg.c */
int make_var();
term *copy_expr();

/* passed between yylex() and bdsyn.y (i.e., yyparse()) */
extern char yytext[1024];
extern int yylength;
extern char *yyfile;
extern int *yyline;

extern char *model_name;

