#include "copyright.h"
#include "port.h"
#include "defs.h"
#include "oct.h"
#include "oh.h"
#include "options.h"
#include "vov.h"

char 		*optProgName;
int		num_longest_nets = 6;
int 		num_nets = 0;
double  	total_net_length = 0.0;
double  	total_net_length2 = 0.0;
double  	total_net_length_var;
double  	total_net_area = 0.0;
double  	total_net_area2 = 0.0;
double  	total_net_area_var;
struct net_length_struct *net_lengths;
int		num_instances = 0;
int		num_connectors = 0;

int		num_vias = 0;
double		tot_instance_area = 0;
double		tot_instance_area2 = 0;
double		tot_instance_area_var = 0;
int		chipWidth;
int		chipHeight;
double		chipArea;

int		bb = 0;		/* flag to show bounding boxes */
char 		buffer[256];

#define FPRINTF	(void) fprintf


optionStruct optionList[] = {
    { "b",	0,		"compute bounding boxes of the nets" },
    { "l",	"integer",	"number of longest nets that will be displayed" },
    { OPT_RARG,	"cell:view",	"cell and view to get statistics on" },
    { 0,	0,		0 }
};


main(argc, argv)
int argc;
char **argv;
{
    int option;
    extern int optind;
    extern char *optarg;
    octObject facet;
    octStatus status;

    while ((option = optGetOption(argc, argv)) != EOF) {
	switch (option) {
	    case 'b':
		bb = 1;
		break;

	    case 'l':
		num_longest_nets = atoi(optarg);
	        break;
	}
    }

    if (argc == optind+1) {
	ohUnpackDefaults(&facet, "r", ":symbolic:contents");
	if (ohUnpackFacetName(&facet, argv[optind]) != OCT_OK) {
	    optUsage();
	}
    } else {
	optUsage();
    }

    /*
     *  Open the facet to be used for this run
     */
    if ((status = octOpenFacet(&facet)) < OCT_OK) {
        if (status == OCT_NO_PERM) {
	    FPRINTF(stderr, "error: facet is unreadable\n");
	    exit(-1);
        }
        FPRINTF(stderr, "error: can not open the facet\n");
        exit(-1);
    }
  
    VOVbegin( argc, argv );
    VOVinputFacet( &facet );
    /* 
     *  Your program goes here operating on 'facet'
     */

    (void) main_net_length(&facet);
    main_chip_area(&facet);
    printAll(&facet);

    octEnd();
    VOVend(0);
}


void
FatalError(es)
     char *es;			/* error string */
{
  FPRINTF(stderr,"%s: Fatal Error: %s\n",optProgName,es);
  octError(optProgName);
  exit(-1);
  /*NOTREACHED*/
}

void
Warning(es)
     char *es;			/* error string */
{
  FPRINTF(stderr, "%s: Warning: %s\n", optProgName, es);
}
