#include "copyright.h"
#include "port.h"
#include "defs.h"

#define PRINTF	(void) printf

#ifndef MIN
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#endif

printAll(facet)
    octObject *facet;
{
  int i;
  char *net_name;
  octObject net;
  double  re_area;		/* routing + empty area */
  double length;

  PRINTF("%s: Version 1.0 : Chip  %s:%s\n",
	 optProgName, facet->contents.facet.cell, facet->contents.facet.view);

  PRINTF("\n");
  PRINTF("\tNumber of instances    = %d\n", num_instances);
  PRINTF("\tNumber of nets         = %d\n", num_nets);
  PRINTF("\tNumber of connectors   = %d\n" , num_connectors);
  PRINTF("\tNumber of vias         = %d\n" , num_vias);

  PRINTF("\n");

  if (num_instances > 0) {
      PRINTF("\tAverage instance area  = %14.2f\n" , tot_instance_area / num_instances);
  }
  PRINTF("\tSt.dev. instance area  = %14.2f\n" , sqrt(tot_instance_area_var));
  PRINTF("\tChip Area W x H        = %6d x%6d\n", chipWidth, chipHeight);
  PRINTF("\tChip Area              = %14.2f (100.00%%)\n", chipArea);
  if (chipArea > 0.0) {
      PRINTF("\tTotal Instance Area    = %14.2f (%6.2f%%)\n" ,
		    (double) tot_instance_area,
		    100.0 * (double) tot_instance_area / chipArea);
  }

  re_area = chipArea - tot_instance_area;
  if (chipArea > 0.0) {
      PRINTF("\tRouting + Empty Area   = %14.2f (%6.2f%%)\n" ,
		    (double) re_area,
		    100.0 * (double) re_area / chipArea);
  }

  PRINTF("\tTotal   net area       = %14.2f\n" , total_net_area);
  PRINTF("\tTotal   net length     = %14.2f\n" , total_net_length);
  if (num_nets > 0) {
      PRINTF("\tAverage net length     = %14.2f\n" , total_net_length / num_nets);
  }
  PRINTF("\tSt.dev. net length     = %14.2f\n" , sqrt(total_net_length_var));

  PRINTF("\n***** %d LONGEST NETS\n", MIN(num_nets, num_longest_nets));
  PRINTF("%-26s %16s %16s\n",
	  "(---) NAME", "LENGTH (lambda)" , "AREA (lambda^2)");
  for(i = 0; i < MIN(num_nets, num_longest_nets); i++) {
    OH_ASSERT(ohGetById(&net, net_lengths[i].objectId));
    if (strrchr(net.contents.net.name,'/')==0) {
      net_name = net.contents.net.name;
    } else {
      net_name = strrchr(net.contents.net.name,'/');
    }
    if (bb) {
      length = net_lengths[i].bbox_length;
    } else {
      length = net_lengths[i].length;
    }
    PRINTF("(%3d) %-20s %16.2f%4s %16.2f\n", i+1,  net_name,
		  length, (bb) ? "(bb)" : "",  net_lengths[i].area);
  }
}
