#include "copyright.h"
#include "port.h"
#include "oct.h"
#include "tr.h"
#include "plotter.h"
#include "xforms.h"

double scale;

extern void getPen();
extern void move();
extern void draw();
extern void sendcoord();

do_circle(cx,cy,ri,ro,sd,ed,pen,fill,lineType)
int cx; /* center x */
int cy; /* center y */
int ri; /* inner radius */
int ro; /* outer radius */
int sd; /* start degrees */
int ed; /* end degrees */
int pen;    /* pen to draw in */
int fill;   /* fill type */
int lineType;   /* line type */
{
    int32 radtmp1,radtmp2;
    double sradinner, sradouter;
    int32 origin1,origin2;

    origin1=origin2=0;
    tr_transform(stack,&origin1,&origin2);
    radtmp1=ri;
    radtmp2=0;
    tr_transform(stack,&radtmp1,&radtmp2);
    radtmp1 -= origin1;
    radtmp2 -= origin2;
    sradinner = scale * sqrt((double)(radtmp1*radtmp1+radtmp2*radtmp2));
    radtmp1=ro;
    radtmp2=0;
    tr_transform(stack,&radtmp1,&radtmp2);
    radtmp1 -= origin1;
    radtmp2 -= origin2;
    sradouter = scale *sqrt((double)(radtmp1*radtmp1+radtmp2*radtmp2)); 
    /*
     *  Draw a circle as described in the arguments 
     */

    if(WhichPen != pen) getPen(pen);
    if(!PenUp) (void) fprintf(PlotterFile,PENUP);  /* make sure pen is up */
    PenUp=1;    /* remember that it is up */

	sd = sd%3600;
	ed = ed%3600;
	if(sd >ed) sd -= 3600;
    if(sd%3600 == ed%3600) {
        /* angles are the same, so complete circles */
        if(ri == 0) {
            /* inner radius 0 -> simple circle */
            MOVE(cx,cy);
            (void) fprintf(PlotterFile,POLYMODE);  /* enter polygon mode */
            (void) fprintf(PlotterFile,CIRCLE,(int)sradouter);  /* basic circle command */
            (void) fprintf(PlotterFile,POLYDONE);  /* end polygon mode */
        } else {
            /* 2 radii - more difficult */
            MOVE(cx,cy);
            (void) fprintf(PlotterFile,POLYMODE);  /* enter polygon mode */
            (void) fprintf(PlotterFile,CIRCLE,(int)sradouter);  /* basic circle command */
            (void) fprintf(PlotterFile,CIRCLE,(int)sradinner);  /* basic circle command */
            (void) fprintf(PlotterFile,POLYDONE);  /* end polygon mode */
        }
    } else {
        /* messy - arcs, not circles */
        if(ri == 0) {
            /* at least we only have one line to worry about */
            MOVE(cx,cy);
            (void) fprintf(PlotterFile,POLYMODE);  /* enter polygon mode */
            DRAW((int)(cx+ro*cos(DTOR*sd)),(int)(cy+ro*sin(DTOR*sd)),pen);
            (void) fprintf(PlotterFile,ARC);
            OUTPT(cx,cy);
            (void) fprintf(PlotterFile,",%d;\n",(int)((ed-sd)/10));/*basic arc command */
            DRAW(cx,cy,pen);
            (void) fprintf(PlotterFile,POLYDONE);  /* end polygon mode */
        } else {
            /* the worst possible case */
            MOVE((int)(cx+ro*cos(DTOR*sd)),(int)(cy+ro*sin(DTOR*sd)));
            (void) fprintf(PlotterFile,POLYMODE);  /* enter polygon mode */
            (void) fprintf(PlotterFile,ARC);
            OUTPT(cx,cy);
            (void) fprintf(PlotterFile,",%d;\n",(int)((ed-sd)/10));/*basic arc command */
            DRAW((int)(cx+ri*cos(DTOR*ed)),(int)(cy+ri*sin(DTOR*ed)),pen);
            (void) fprintf(PlotterFile,ARC);
            OUTPT(cx,cy);
            (void) fprintf(PlotterFile,",%d;\n",(int)((sd-ed)/10));/*basic arc command */
            DRAW((int)(cx+ro*cos(DTOR*sd)),(int)(cy+ro*sin(DTOR*sd)),pen);
            (void) fprintf(PlotterFile,POLYDONE);  /* end polygon mode */
        }
    }
    /* now to decide about filling */
    if(ri != ro) {
        if(fill & FILL) {
            if(lineType != 0) {
                (void) fprintf(PlotterFile,"LT%d;\n",lineType);
            } else {
                (void) fprintf(PlotterFile,"LT;\n");
            }
            (void) fprintf(PlotterFile,FILLPOLY);  /* polygon fill */
            (void) fprintf(PlotterFile,"LT;\n");
        }
    }
    if(fill & OUTLINE) {
        (void) fprintf(PlotterFile,EDGEPOLY);  /* polygon outline */
    }
}
