#include "copyright.h"
#include "port.h"
#include "plotter.h"

void move();
void draw();
void sendpoint();
void sendcoord();
extern void getPen();

double scale;
int xmin;
int ymin;
int xoffset;
int yoffset;

void
move(x,y)
int x,y;
{
    /*
     *  Move the pen to the specified position without drawing 
     */
    if(!PenUp) (void) fprintf(PlotterFile,PENUP);  /* make sure the pen is up */
    PenUp=1;        /* and remember that fact! */
    sendpoint(&x,&y);   /* send the coords of the point */
}

void
draw(x,y,pen)
int x,y,pen;
{
                
    /*
     *  Draw a line from the previous point to the specified point
     */

    if(WhichPen != pen) getPen(pen);
    if(PenUp) (void) fprintf(PlotterFile,PENDOWN); /* be sure pen is down */
    PenUp=0;    /* remember that it is down */
    sendpoint(&x,&y);   /* just send the points coords -must already */
                /* have an initial point */
                /* specified or call to draw is meaningless  */
}


void sendpoint(x,y)
int *x,*y;
{

    /*
     *  Send a point to the plotter
     */

    /*
     * some special scaling 
     */
    (void) fprintf(PlotterFile,"PA%d,%d;\n",(int)(((*x-xmin)*scale)+(MINX+xoffset)),(int)(((*y-ymin)*scale)+(MINY+yoffset)));
    savedx = *x;
    savedy = *y;
    savedValid = 1;
}

void sendcoord(x,y)
int x,y;
{

    /*
     *  Send a coordinate to the plotter
     */

    /*
     * some special scaling 
     */
    (void) fprintf(PlotterFile,"%d,%d",(int)(((x-xmin)*scale)+(MINX+xoffset)),(int)(((y-ymin)*scale)+(MINY+yoffset)));
    savedx = x;
    savedy = y;
    savedValid = 1;
}

