
    /* 
     * HP plotter definition - these are dependent on the
     * SPECIFIC MODEL of HP plotter used, and should always
     * be modified when going to a new plotter.
     * 
     * all dimensions are in plotter units.
     *
     * MINX and MINY are the smallest x and y values that
     * are inside the soft clip limits of the plotter
     * MAXX and MAXY are the largest x and y values that
     * are inside the soft clip limits of the plotter MINUS
     * MINX and MINY, so they give the dimension of the
     * soft clip area.
     *
     * PLOTTERTYPE is a character string which identifies the
     * plotter that should be used.  control information will
     * be read for ~octtools/lib/technology/$TECHNOLOGY/$PLOTTERTYPE.map
     * and output will go to /usr/ucb/lpr -Pplt$PLOTTERTYPE
     *
     */
/* max USABLE coords - doesn't include first MIN units */
/* note:  increased MIN's by 200 to allow for labels */
/* also reduced MAX's by an EXTRA 200 to make symetric without labels */
#define MAXX 41280.0
#define MAXY 31960.0
#define MINX -20640
#define MINY -15980
#define PLOTTERTYPE "7585"
#define PLOTTERNAME "bigPlotter"

    /*
     *  HP plotter specific commands - these are from the definition
     *  of the HPGL graphics language.
     */

#define NOPEN "SP;"
#define PEN1 "SP1;"
#define PENDOWN "PD;"
#define PENUP "PU;"
#define POLYMODE "PM0;"
#define POLYDONE "PM2;"
#define CIRCLE "CI%d;"
#define ARC "AA"
#define FILLPOLY "FP;"
#define EDGEPOLY "EP;"
#define RECTFILL "RA"
#define RECTEDGE "EA"
#define PORTLABELSETUP "DI1,0;SI.18,.25;"
#define LANDLABELSETUP "DI0,1;SI.18,.25;"
#define LABEL "LB%s\003;"

#define FILL 0x1
#define OUTLINE 0x2
#define SOLID 0x4
#define CROSS 0x8

/* funny definition, but oct's D's are really tenths of degrees */
#define DTOR ((double)(3.141592654/1800.0))

extern FILE *PlotterFile;
extern int PenUp;
extern int WhichPen;
extern int savedx;
extern int savedy;
extern int savedValid;
