#include "copyright.h"
#include "port.h"
#include "plotter.h"


FILE *PlotterFile;
int PenUp;
int savedx;
int savedy;
int savedValid;
int WhichPen;
char *plotter;

/* what we define */
void cleanup();
void init();

static char file[4096];

void
init()
{

   /*
    *
    *   Perform device dependent initialization:
    *
    *   We need to send raw HPGL out to the plotter.  Unfortunately,
    *   we won't know how successful we will be until we write all of the
    *   HPGL.  So...  We open a file in /usr/tmp and write our stuff
    *   out there for now, when we close, we will lpr that file.
    *   If everything goes wrong, we remove the file and exit.
    *
    */

    if (strcmp(plotter, "-") == 0) {
	PlotterFile = stdout;
    } else {
	(void) strcpy(file,"/usr/tmp/hpgl-XXXXXX");
	(void) mktemp(file);

	if ((PlotterFile = fopen(file,"w")) == NULL) {
	    /* can't get lpr - need to print error */
	    perror(file);
	    cleanup();
	    exit(1);
	}
    }

    /*
     *  remember that after the initilization caused by
     *  opening the device, the pen is up, and we must ask
     *  the user to put some paper in.
     */
    (void) fprintf(PlotterFile,"IN;\nPG;\n");
    PenUp=1;
    WhichPen=0;
    savedx=savedy=0;
    savedValid=0;

    return;
}



void
cleanup()
{
    char cmd[4096];

    /*
     *  Perform necessary cleanup operations after plotting
     */
    /*
     *  put the pen away and close the plotter
     */
    (void) fprintf(PlotterFile,PENUP); /* make sure we don't drag it! */
    (void) fprintf(PlotterFile,NOPEN); /* put it away */
    (void) fprintf(PlotterFile,"PG1;\n");    /* put it away */
    (void) fclose(PlotterFile);    /* and close the 'device' */
    /* 
     * now we transfer the file to the acutal plotter 
     */
    
    if (strcmp(plotter, "-") != 0) {
        (void) sprintf(cmd, "/usr/ucb/lpr -P%s %s", plotter, file);
        if(system(cmd)) {
            perror(cmd);
        }
        (void) sprintf(cmd,"/bin/rm %s",file);
        if(system(cmd)) {
            perror(cmd);
        }
    }
    return;
}
