#include "copyright.h"
#include "port.h"
#include "oct.h"
#include "oh.h"

main(argc, argv)
int argc;
char **argv;
{
    octObject facet;
    octStatus status;

    if (argc != 2) {
	(void) fprintf(stderr, "usage: %s cell:view\n", argv[0]);
	exit(2);
    }

    ohUnpackDefaults(&facet, "r", "::contents");
    if (ohUnpackFacetName(&facet, argv[1]) < OCT_OK) {
	(void) fprintf(stderr, "usage: %s cell:view\n", argv[0]);
	exit(2);
    }

    status = octOpenFacet(&facet);
    if ( status != OCT_OLD_FACET ) {
	switch ( status ) {
	case OCT_ERROR:
	case OCT_NO_PERM:
	case OCT_NO_EXIST:
	case OCT_CORRUPTED_OBJECT:
	    octError( "Cannot open facet" );
	    exit( 1 );
	case OCT_INCONSISTENT:
	    ohPrintInconsistent(&facet, stdout);
	    exit( 1 );
	default:
	    octError( "Strange error code" );
	    exit( 1 );
	}
    }

    exit(0);
}
