#include "port.h"
#include "mag2oct.h"

extern    char    *logfile;
extern    FILE    *fp_logfile;
extern    int    exit_val;

void
logmsg(level, fmt, a, b, c, d)
int    level;        /* -1 Fatal, 0 Normal message, 1 Warning */
char    *fmt;
char    *a, *b, *c, *d;
{
    if (verbose || level == -1) {
        (void) fprintf(stderr, fmt, a, b, c, d);
    }

#ifdef    notdef
    if (level != 0
#ifdef    DEBUG
            || debug
#endif
                ) {
#endif
        if (fp_logfile == 0) {
            if ((fp_logfile = fopen(logfile, "a")) == NULL) {
                if (verbose) {
                    (void) fprintf(stderr, "%s: Unable to append to logfile: ", arg0);
                    perror(logfile);
                }
                exit(-1);        /* Fatal error */
            }
        }

        (void) fputs("mag2oct> ", fp_logfile);
        (void) fprintf(fp_logfile, fmt, a, b, c, d);
#ifdef    notdef
    }
#endif

    switch (level) {
	case 1:
	    exit_val = 1;        /* Set warning */
	case 0:
	    break;
	case -1:
	    exit(-1);        /* Fatal error */
	default:
	    if (verbose)
		(void) fprintf(stderr,
		    "%s: Internal Error: Unknown log level\n", arg0);
	    exit_val = 1;        /* Set warning */
    }
    return;
}

