#include "copyright.h"
#include "port.h"
#include "st.h"
#include "oct.h"
#include "utility.h"

#define FPRINTF	(void) fprintf

extern char *optProgName;

static st_table *facet_table;

void
init_cell_table()
{
  extern int octIdCmp(), octIdHash();
  facet_table = st_init_table(octIdCmp, octIdHash);
}

int
lookup_cell(facet, value)
     struct octObject *facet;
     char **value;
{
    char *foo;

    if (st_lookup(facet_table, (char *) &facet->objectId, &foo)) {
      if (value) {
	*value = foo;
      }
      return 1;
    }
    return 0;
}

void
add_cell(facet, number)
struct octObject *facet;
int number;
{
    octId *id = ALLOC(octId, 1);
    *id = facet->objectId; 
    st_insert(facet_table, (char *) id, (char *) number);
}

void
error(string)
char *string;
{
int status;
    FPRINTF(stderr, "%s:%s", optProgName, string);
    octError("");
    exit(1);
}

void
warning(string)
char *string;
{
    FPRINTF(stderr, "%s:%s", optProgName, string);
    octError("");
}

void
inst_to_master(instance, master)
octObject *instance, *master;
{
    master->type = OCT_FACET;
    master->contents.facet.cell = instance->contents.instance.master;
    master->contents.facet.view = instance->contents.instance.view; 
    master->contents.facet.facet = "contents";
    master->contents.facet.mode = "r";
    master->contents.facet.version = instance->contents.instance.version;
    return;
}
