#include "copyright.h"
#include "port.h"
#include "oct.h"

#define NIL(type) ((type *) 0)

#define FPRINTF	(void) fprintf

static int pt_arr_size = 0;
static struct octPoint *pt_arr;

get_points(obj, num, arr)
octObject *obj;
int *num;
struct octPoint **arr;
{
    int status;
    int32 num_points;

    if (pt_arr_size == 0) {
	pt_arr_size = 50;
	pt_arr = (struct octPoint *)
	  malloc((unsigned)pt_arr_size*sizeof(struct octPoint));
	if (pt_arr == NIL(struct octPoint)) {
	    FPRINTF(stderr, "Out of Memory\n");
	    exit(-1);
	}
    }
    
    num_points = pt_arr_size;
    status = octGetPoints(obj, &num_points, pt_arr);
    if (status != OCT_OK) {
	if (status != OCT_TOO_SMALL) {
	    return status;
	} else {
	    pt_arr_size = num_points;
	    pt_arr = (struct octPoint *)
	      realloc((char *) pt_arr,
		      (unsigned) num_points*sizeof(struct octPoint));
	    if (pt_arr == (struct octPoint *) 0) {
		FPRINTF(stderr, "Out of Memory\n");
		exit(-1);
	    }
	    if ((status = octGetPoints(obj, &num_points, pt_arr)) != OCT_OK) {
		return status;
	    }
	}
    }
    *num = num_points;
    *arr = pt_arr;
    
    return OCT_OK;
}
