#include "copyright.h"
#define PANIC(str)	((void) fprintf(stderr,				\
			    "%s: internal error (%s) at %s:%d\n",	\
			    optProgName, (str), __FILE__, __LINE__), exit(2))
#undef OCT_ASSERT
#define OCT_ASSERT(ret)	if ((ret) < OCT_OK) {				\
			    ((void) fprintf(stderr,			\
				"%s: unexpected oct error (%s) at %s:%d\n", \
				optProgName, octErrorString(),		\
				__FILE__, __LINE__));			\
			    exit(2);					\
			}




typedef struct _matchTable {
    struct _matchTable *parent;		/* matchTable this one modifies */
    int flags;				/* matching conditions */
    jmp_buf jmpBuf;			/* exit point for QUICK_CKECK */
    unsigned errorP : 1;		/* any errors in this match table? */
    st_table *table;			/* lookup table of matches */
    lsList matchedList;			/* list of matched objs to gen from */
    lsList sloppyList;			/* objs with ambiguous attachments */
} matchTable;

/* flags for `flags' */
#define QUICK_CHECK	0x1
#define INEXACT		0x2
#define GUESS		0x4




typedef struct {
    octId matchId;		/* matching object's id (or oct_null_id) */
    char objFlags;		/* flags pertaining to this object */
    char contentsFlags;		/* flags concerning contents objs */
    char containersFlags;	/* flags concerning containing objs */
} matchData;

/* flags for `objFlags' */
#define FACET_1_P	0x1	/* obj is in facet1, not facet2 */
#define MATCHED_P	0x2	/* object has been matched */
#define UNMATCHED_P	0x4	/* object can't be matched */

/* flags for `contentsFlags' and `containersFlags' */
#define CHECKED_P	0x1	/* attachments have been checked */
#define DIFFERENT_P	0x2	/* attachments are known to be different */
#define SLOPPY_P	0x4	/* there are some approximately matched objs */

#ifdef OCT_JUST_LEFT
#define OCT_VERSION	2
#else
#define OCT_VERSION	1
#endif

extern octObject facet1;	/* first facet to be compared */
extern octObject facet2;	/* second facet to be compared */

extern matchTable *curMatchTablePtr;

extern void pushTable(), popTable();
extern matchData *getMatchData();
extern int recycleSloppyObjs(), recycleErrorObjs();
extern octId nextMatchedObj();
extern void markObject(), markContents(), markContainers(), markUnmatchable();
extern int markMatched();
extern int compareObj();
