/*		PRINT CRITICAL PAIR INFORMATION
*		-------------------------------------
*
*   File:	crit_pr.c
*   Author: Umakanta Choudhury
*   Date:   3rd July
*
*/


#include <stdio.h>
#include "circuit.h"
#include "layout.h"
/* #include "cap_library.h" */

REPORT crit_pr(circuit,layout,debug_file)

struct Circuit *circuit;	/* the circuit structure */
struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
    struct CriticalPairLink	*critpair_link;
    struct Chan_info	*chan_info;
	int	i;

	fprintf(debug_file,"\ncrit_pr.c\n");

	for(critpair_link = layout->critical_pairs; critpair_link != NULL; 
				critpair_link = critpair_link->next){ 
		fprintf(debug_file,"\ncrit_pair (%s,%s) present in:\n",
			critpair_link->netA_name,critpair_link->netB_name);
		for(chan_info = critpair_link->chan_info_list; 
				chan_info != NULL; chan_info = chan_info->next){
			fprintf(debug_file,"channel %s\n",chan_info->channel->name);
			fprintf(debug_file,"netA %s netB %s\n",chan_info->netA->name,
			chan_info->netB->name);
			fprintf(debug_file,"Lx_max = %g, Ly_max = %g\n",
				chan_info->Lx_max,chan_info->Ly_max);
		}
		for(i=1; i<=circuit->num_perf; i++){
			fprintf(debug_file,"%s pos_sens = %g neg_sens = %g\n",
			*(layout->perf_name + i),*(critpair_link->pos_sens + i),
			*(critpair_link->neg_sens + i));
		}
	}
	fprintf(debug_file,"cap_threshold = %g\n",layout->cap_threshold);

	return(OK);
}
