/*      ROUTINE FOR PRINTING 
*		MINIMUM POSSIBLE CHANGE IN 
*		PERFORMANCE WITHOUT SHIELDING
*       ---------------------------------------
*
*   File:       delta_min_pr.c
*   Author:     Umakanta Choudhury
*   Date:       22nd June 1989
*
*
*/

#include <stdio.h>
#include "layout.h"
#include "circuit.h"



REPORT delta_min_pr(layout,circuit,debug_file)
struct Layout *layout;
struct Circuit *circuit;
FILE *debug_file;
{
	struct Performance *perf;


	fprintf(debug_file,"\ndelta_min_pr.c\n");

	fprintf(debug_file,"before shielding:\n");
	for(perf = circuit->perf_list; perf != NULL; perf = perf->next){
		fprintf(debug_file,"performance %s :\n",perf->name);
		if(perf->pos_constraint == YES){
		/* constraint on maximum positive change present */
			fprintf(debug_file,"max_pos_change = %f,delta_pos_min = %f\n"
				,perf->max_pos_change,perf->delta_pos_min);
		}
		if(perf->neg_constraint == YES){
		/* constraint on maximum negative change present */
			fprintf(debug_file,"max_neg_change = %f,delta_neg_min = %f\n"
				,perf->max_neg_change,perf->delta_neg_min);
		}
	}
	return(OK);
}
