/*  find_link.c
 *
 *   Author:     Umakanta Choudhury
 *   Date:       30th June 1989
 *   Last modified:  Enrico Malavasi,  Aug. 1992
 *
 *   Purpose: Find a link in the "pos_sens_link" and/or "neg_sens_link"
 *		lists of a performance function
 */
#include <stdio.h>
#include <string.h>
#include "circuit.h"
#include "layout.h"

struct Sens_link  *
  find_link(perf, nameA, nameB, flag)
struct	Performance *perf;
char	*nameA;
char	*nameB;
int      flag;
{

    struct	Sens_link	*sens_link;
    
    if((flag == POS_LIST) || (flag == BOTH_LISTS)){
	for(sens_link=perf->pos_sens_list ; sens_link!=NULL ; sens_link=sens_link->next){
	    if( (strcmp(sens_link->nodeA->name, nameA) == 0) &&
	       (strcmp(sens_link->nodeB->name, nameB) == 0)){
		/*  EUREKA  */
		return sens_link;
	    }
	    /* try the reverse order */
	    if( (strcmp(sens_link->nodeA->name,nameB) == 0) &&
	       (strcmp(sens_link->nodeB->name,nameA) == 0)){
		/*  EUREKA  */
		return sens_link;
	    }
	}
    }
    if((flag == NEG_LIST) || (flag == BOTH_LISTS)){
	for(sens_link = perf->neg_sens_list; sens_link != NULL; sens_link = sens_link->next){
	    if( (strcmp(sens_link->nodeA->name,nameA) == 0) &&
	       (strcmp(sens_link->nodeB->name,nameB) == 0)){
		/*  EUREKA  */
		return sens_link;
	    }
	    /* try the reverse order */
	    if( (strcmp(sens_link->nodeA->name,nameB) == 0) &&
	       (strcmp(sens_link->nodeB->name,nameA) == 0)){
		/*  EUREKA  */
		return sens_link;
	    }
	}
    }

    return NULL;
}
