/*      ROUTINE FOR INITIALIZING PERFORMANCE 
*       STRUCTURE 
*       --------------------------------
*
*   File:       init_crit.c
*   Author:     Umakanta Choudhury
*   Date:       28th June 1989
*
*
*/

#include <stdio.h>
#include "utility.h"
#include "circuit.h"
#include "layout.h"

extern int strcmp();

REPORT init_crit(critpair,nameA,nameB,num_perf)
struct CriticalPairLink *critpair;
char *nameA;
char *nameB;
int num_perf;
{
	int i;

  	critpair->netA_name = util_strsav(nameA);
   	critpair->netB_name = util_strsav(nameB);
	critpair->chan_info_list = NULL;

	if((critpair->pos_sens = (float *)malloc((num_perf + 1)*
		sizeof(float))) == NULL){
		printf("out of memory\n");
		return ERROR;
	}
	if((critpair->neg_sens = (float *)malloc((num_perf + 1)*
		sizeof(float))) == NULL){
		printf("out of memory\n");
		return ERROR;
	}
	for(i = 1; i<= num_perf; i++){
		*(critpair->pos_sens + i) = 0;
	}
	for(i = 1; i<= num_perf; i++){
		*(critpair->neg_sens + i) = 0;
	}
	return(OK);
	
}
