/*		PRINT LAYOUT INFORMATION
*		-------------------------------------
*
*   File:	layout_pr.c
*   Author: Umakanta Choudhury
*   Date:   10th June
*
*/


#include <stdio.h>
#include "layout.h"
/* #include "cap_library.h" */

REPORT layout_pr(layout,debug_file)

struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
    struct ChannelLink	*chan_link;
    struct Channel	*channel;
    struct NetLink	*net_link;
    struct Net		*net;
    struct PinLink	*pin_link;
    struct Pin		*pin;
	int	i;


	fprintf(debug_file,"\nlayout_pr.c\n");

	for(chan_link = layout->chan_list; chan_link != NULL; 
				chan_link = chan_link->next){ 

		channel = chan_link->channel;
		
		fprintf(debug_file,"chan_name  %s :\n",channel->name);
		if(channel->orient == TOP_BOTTOM) 
			fprintf(debug_file,"orientation TOP_BOTTOM \n");
		else if(channel->orient == LEFT_RIGHT) 
			fprintf(debug_file,"orientation LEFT_RIGHT \n");
		fprintf(debug_file,"chan_left = %g :\n",channel->left);
		fprintf(debug_file,"chan_right = %g :\n",channel->right);
		fprintf(debug_file,"chan_bottom = %g :\n",channel->bottom);
		fprintf(debug_file,"chan_top = %g :\n",channel->top);

		for(net_link = channel->net_list; net_link != NULL; net_link = 
					net_link->next){
			net = net_link->net;
			fprintf(debug_file,"net_name  %s :\n",net->name);
			fprintf(debug_file,"pin_info:\n");
			for(pin_link = net->pins; pin_link != NULL; pin_link = 
						pin_link->next){
				pin = pin_link->pin;
				fprintf(debug_file,"x_position=%g y_position = %g ",
					pin->x_position,pin->y_position);
				if(pin->edge == TOP) 
					fprintf(debug_file,"on TOP edge\n");
				else if(pin->edge == BOTTOM) 
					fprintf(debug_file,"on BOTTOM edge\n");
				else if(pin->edge == LEFT) 
					fprintf(debug_file,"on LEFT edge\n");
				else if(pin->edge == RIGHT) 
					fprintf(debug_file,"on RIGHT edge\n");
			}
		}
	}
	return(OK);
}
