/*		PRINT MAXIMUM AND MINIMUM CAP INFORMATION
*		-----------------------------------------
*
*   File:	maxmin_pr.c
*   Author: Umakanta Choudhury
*   Date:   10th June
*
*/


#include <stdio.h>
#include "layout.h"
/* #include "cap_library.h" */

REPORT maxmin_pr(layout,debug_file)

struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
    struct CriticalPairLink	*critpair;
    struct Chan_info	*chan_info;
    struct Channel	*channel;

	fprintf(debug_file,"\nmaxmin_pr.c\n");

	for(critpair = layout->critical_pairs; critpair != NULL; 
				critpair = critpair->next){ 
		fprintf(debug_file,"\ncritical pair (%s,%s) :\n",
			critpair->netA_name,critpair->netB_name);
		for(chan_info = critpair->chan_info_list; chan_info != NULL;
			chan_info = chan_info->next){

			channel = chan_info->channel;
			fprintf(debug_file,"\nchannel %s :\n",channel->name);
			fprintf(debug_file,"Cx_max %g \n",chan_info->Cx_max);
			fprintf(debug_file,"Cx_min %g \n",chan_info->Cx_min);
			fprintf(debug_file,"Cy_max %g \n",chan_info->Cy_max);
			fprintf(debug_file,"Cy_min %g \n",chan_info->Cy_min);
			fprintf(debug_file,"Ccross_max %g \n",chan_info->Ccross_max);
			fprintf(debug_file,"Ccross_min %g \n",chan_info->Ccross_min);
			fprintf(debug_file,"C_max %g \n",chan_info->C_max);
			fprintf(debug_file,"C_min %g \n",chan_info->C_min);
		}
	}
	return(OK);
}
