/*		PRINT PERFORMANCE AND CIRCUIT
*		RELATED INFORMATION
*		-------------------------------------
*
*   File:	perf_pr.c
*   Author: Umakanta Choudhury
*   Date:   17th June
*
*/


#include <stdio.h>
#include "circuit.h"
#include "layout.h"
/* #include "cap_library.h" */

REPORT perf_pr(circuit,layout,debug_file)

struct Circuit *circuit;	/* the circuit structure */
struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
    struct Matched_pair	*matchpair;
	struct Performance *performance;
	struct Node *node;
	int	i;

	fprintf(debug_file,"\nperf_pr.c\n");

	fprintf(debug_file,"num_nodes = %d\n",circuit->num_nodes);
	for(node = circuit->node_list; node != NULL; 
				node = node->next){ 
		fprintf(debug_file,"node name = %s\n",node->name);
		if(node->matched == YES){
			fprintf(debug_file,"matched\n");
		}
		else{
			fprintf(debug_file,"not matched\n");
		}
	}
	for(matchpair = circuit->matched_pair_list; matchpair != NULL; 
				matchpair = matchpair->next){ 
		fprintf(debug_file,"match pair (%s,%s) \n",
			matchpair->nodeA->name,matchpair->nodeB->name);
	}
	for(performance = circuit->perf_list; performance != NULL; 
				performance = performance->next){ 
		fprintf(debug_file,"performance name = %s\n",performance->name);
		if(performance->pos_constraint == YES){
			fprintf(debug_file,"max_pos_change = %g\n",performance->
			max_pos_change);
		}
		if(performance->neg_constraint == YES){
			fprintf(debug_file,"max_neg_change = %g\n",performance->
			max_neg_change);
		}
	}
	return(OK);
}
