/*      ROUTINE FOR REMOVING A LINK 
*       FROM THE "Sens_link" list 
*		IF IT EXISTS
*       --------------------------------
*
*   File:       remove_link.c
*   Author:     Umakanta Choudhury
*   Date:       30th June 1989
*
*
*/

#include <stdio.h>
#include "circuit.h"
#include "layout.h"

extern int strcmp();

REPORT remove_link(sens_link_list_ptr,nameA,nameB)
struct	Sens_link **sens_link_list_ptr;
char	*nameA;
char	*nameB;
{
	struct Sens_link *link;
	struct Sens_link *prev_link;
	struct Sens_link *next_link;

	for(link = *sens_link_list_ptr; link != NULL; link = link->next){
		if(((strcmp(link->nodeA->name,nameA) == 0) &&
			(strcmp(link->nodeB->name,nameB) == 0)) ||
		((strcmp(link->nodeA->name,nameB) == 0) &&
			(strcmp(link->nodeB->name,nameA) == 0))) {
			/* found the link */
			next_link = link->next;
			prev_link = link->prev;
			if(next_link != NULL) next_link->prev = prev_link;
			if(prev_link != NULL) prev_link->next = next_link;
			else *sens_link_list_ptr = next_link;
			free(link);
			return(OK);
		}
	}
	return(OK); /* the link not found */
}
