/*		PRINT MATCHED SENSITIVITY 
*		INFORMATION
*		-------------------------------------
*
*   File:	sens_match_pr.c
*   Author: Umakanta Choudhury
*   Date:   30th June
*
*/


#include <stdio.h>
#include "circuit.h"
#include "layout.h"
/* #include "cap_library.h" */

REPORT sens_match_pr(circuit,layout,debug_file)

struct Circuit *circuit;	/* the circuit structure */
struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
	struct Performance *perf;
	struct Sens_link *sens_link;

	fprintf(debug_file,"\nsens_match_pr.c\n");

	fprintf(debug_file,"num_nodes = %d\n",circuit->num_nodes);
	for(perf = circuit->perf_list; perf != NULL; 
				perf = perf->next){ 
		fprintf(debug_file,"performance name = %s\n",perf->name);
		fprintf(debug_file,"node1	node2	sensitivity\n");
		for(sens_link = perf->pos_sens_list; sens_link != NULL;
			sens_link = sens_link->next){
			fprintf(debug_file,"%s		%s		%g\n",
				sens_link->nodeA->name,sens_link->nodeB->name,
				sens_link->sens);
		}
		for(sens_link = perf->neg_sens_list; sens_link != NULL;
			sens_link = sens_link->next){
			fprintf(debug_file,"%s 		%s 		%g\n",
				sens_link->nodeA->name,sens_link->nodeB->name,
				sens_link->sens);
		}
	}
	return(OK);
}
