/*		PRINT SENSITIVITY 
*		INFORMATION
*		-------------------------------------
*
*   File:	sens_pr.c
*   Author: Umakanta Choudhury
*   Date:   29th June
*
*/


#include <stdio.h>
#include "circuit.h"
#include "layout.h"
/* #include "cap_library.h" */

REPORT sens_pr(circuit,layout,debug_file)

struct Circuit *circuit;	/* the circuit structure */
struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
	struct Performance *perf;
	struct Sens_link *sens_link;
	struct Chan_info *chan_info;

	fprintf(debug_file,"\nsens_pr.c\n");

	fprintf(debug_file,"num_nodes = %d\n",circuit->num_nodes);
	for(perf = circuit->perf_list; perf != NULL; 
				perf = perf->next){ 
		fprintf(debug_file,"performance name = %s\n",perf->name);
		fprintf(debug_file,"node1	node2	sensitivity\n");
		for(sens_link = perf->pos_sens_list; sens_link != NULL;
			sens_link = sens_link->next){
			fprintf(debug_file,"%s		%s		%g\n",
				sens_link->nodeA->name,sens_link->nodeB->name,
				sens_link->sens);
				/*
			for(chan_info = sens_link->chan_info_list; 
				chan_info != NULL; chan_info = chan_info->next){
				fprintf(debug_file,"present in : \n");
				fprintf(debug_file,"channel %s\n",
					chan_info->channel->name);
			}
					*/
		}
		for(sens_link = perf->neg_sens_list; sens_link != NULL;
			sens_link = sens_link->next){
			fprintf(debug_file,"%s 		%s 		%g\n",
				sens_link->nodeA->name,sens_link->nodeB->name,
				sens_link->sens);
				/*
			for(chan_info = sens_link->chan_info_list; 
				chan_info != NULL; chan_info = chan_info->next){
				fprintf(debug_file,"present in : \n");
				fprintf(debug_file,"channel %s\n",
					chan_info->channel->name);
			}
					*/
		}
	}
	return(OK);
}
