/*    senscalc.c
*
*   Author: Umakanta Choudhury, Enrico Malavasi
*   Last update: July 1992
*/
#include <stdio.h>
#include <string.h>
#include "circuit.h"
#include "macros.h"

void
  create_node_file(circuit, filename)
struct Circuit *circuit; /* The circuit structure */
char  *filename;
{
    FILE *text_file; 
    struct Node *node;

    /* Open the text file */
    if( (text_file = fopen(filename,"w")) == NULL) {
        fprintf(stderr, "\nE: could not open file %s",filename);
	exit( -1 );
    }
    fprintf(text_file,"num_nodes %d out_node1 %s out_node2 %s simulator %s\n",
	    circuit->num_nodes,circuit->out_node1_name,
	    circuit->out_node2_name,circuit->sim_name);
    
    for(node = circuit->node_list; node != NULL; 
        node = node->next) {
        fprintf(text_file,"%s\n",node->name);
    }

    fclose(text_file);
}


void
  create_senscalc_inp(circuit, filename)
struct Circuit *circuit; /* The circuit structure */
char  *filename;
{
    struct Performance *perf; /* The performance structure */
    FILE *text_file;

    /* Open the text file */
    if( (text_file = fopen(filename,"w")) == NULL) {
        printf("\nE: could not open file %s",filename);
	exit( -1 );
    }

    for(perf = circuit->perf_list; perf != NULL; 
        perf = perf->next){ 

        fprintf(text_file,"%s\n",perf->name);
        fprintf(text_file,"%s\n",perf->ckt_file_name);
        if(perf->next != NULL)
        fprintf(text_file,"$\n");
    }
    fclose(text_file);
}
