/*      ROUTINE FOR PRINTING 
*		SHIELDING INFORMATION 
*       ---------------------
*
*   File:       shield_pr.c
*   Author:     Umakanta Choudhury
*   Date:       25th June 1989
*
*
*/

#include <stdio.h>
#include "layout.h"
#include "circuit.h"



REPORT shield_pr(layout,circuit,debug_file)
struct Layout *layout;
struct Circuit *circuit;
FILE *debug_file;
{
	struct Performance *perf;
	struct CriticalPairLink *critpair;
	struct Chan_info *chan_info;


	fprintf(debug_file,"\nshield_pr.c\n");

	fprintf(debug_file,"after shielding:\n");
	for(perf = circuit->perf_list; perf != NULL; perf = perf->next){
		fprintf(debug_file,"performance %s :\n",perf->name);
		if(perf->pos_constraint == YES){
		/* constraint on maximum positive change present */
			fprintf(debug_file,"max_pos_change = %f,delta_pos_min = %f\n"
				,perf->max_pos_change,perf->delta_pos_min);
		}
		if(perf->neg_constraint == YES){
		/* constraint on maximum negative change present */
			fprintf(debug_file,"max_neg_change = %f,delta_neg_min = %f\n"
				,perf->max_neg_change,perf->delta_neg_min);
		}
	}
	fprintf(debug_file,"shielding information:\n");
	for(critpair = layout->critical_pairs; critpair != NULL;
		critpair = critpair->next){
		for(chan_info = critpair->chan_info_list; chan_info 
			!= NULL; chan_info = chan_info->next){
			if(chan_info->shielded == YES){
				fprintf(debug_file,"crit pair (%s,%s) chan %s\n",
					critpair->netA_name,critpair->netB_name,chan_info->
					channel->name);
			}
		}
	}
	return(OK);
}
