/*		PRINT MAXIMUM AND MINIMUM SPAN INFORMATION
*		-----------------------------------------
*
*   File:	span_pr.c
*   Author: Umakanta Choudhury
*   Date:   18th July
*
*/


#include <stdio.h>
#include "layout.h"

REPORT span_pr(layout,debug_file)

struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
    struct ChannelLink	*chan_link;
    struct Channel	*channel;
    struct NetLink	*net_link;
    struct Net	*net;

	fprintf(debug_file,"\nspan_pr.c\n");

	for(chan_link = layout->chan_list; chan_link != NULL; 
		chan_link = chan_link->next){ 

		channel = chan_link->channel;
		fprintf(debug_file,"\nchannel %s:\n",channel->name);

		for(net_link = channel->net_list; net_link != NULL; 
			net_link = net_link->next){ 

			net = net_link->net;
			fprintf(debug_file,"net %s :\n",net->name);
			fprintf(debug_file,"max_left = %g, max_right = %g :\n"
				,net->max_span_left,net->max_span_right);
			fprintf(debug_file,"min_left = %g, min_right = %g :\n"
				,net->min_span_left,net->min_span_right);
		}
	}
	return(OK);
}
