/*		PRINT SUBLIST INFORMATION FOR EACH CHANNEL
*		-----------------------------------------------
*
*   File:	sublist_pr.c
*   Author: Umakanta Choudhury
*   Date:   11th July
*
*/


#include <stdio.h>
#include "layout.h"

REPORT sublist_pr(layout,debug_file)
struct Layout *layout;	/* the layout structure */
FILE *debug_file;

{
    struct ChannelLink	*chan_link;
    struct Channel	*channel;
    struct Pin_list_link	*pin_list_link;
    struct PinLink	*pin_link;

	fprintf(debug_file,"\nsublist_pr.c\n");


	for(chan_link = layout->chan_list; chan_link != NULL; 
				chan_link = chan_link->next){

		channel = chan_link->channel;
		fprintf(debug_file,"channel  %s :\n",channel->name);

		for(pin_list_link = channel->top_pin_lists; 
			pin_list_link != NULL; pin_list_link = pin_list_link->next){
			if(pin_list_link->channel != NULL)
				fprintf(debug_file,"\t sublist after top channel %s \n",
				pin_list_link->channel->name);
			else fprintf(debug_file,"\t first sublist on top \n");
			for(pin_link = pin_list_link->pin_list; 
				pin_link != NULL; pin_link = pin_link->next){
				fprintf(debug_file,"\t (%g,%g) \n",
					pin_link->pin->x_position,
					pin_link->pin->y_position);
			}
		}

		for(pin_list_link = channel->bottom_pin_lists; 
			pin_list_link != NULL; pin_list_link = pin_list_link->next){
			if(pin_list_link->channel != NULL)
				fprintf(debug_file,"\t sublist after bottom channel %s\
				\n",pin_list_link->channel->name);
			else fprintf(debug_file,"\t first sublist on bottom \n");
			for(pin_link = pin_list_link->pin_list; 
				pin_link != NULL; pin_link = pin_link->next){
				fprintf(debug_file,"\t (%g,%g) \n",
					pin_link->pin->x_position,
					pin_link->pin->y_position);
			}
		}
		if(channel->last_top_chan_link != NULL){
			fprintf(debug_file,"\t last_top_chan %s\n",
				channel->last_top_chan_link->channel->name);
		}
		if(channel->last_bottom_chan_link != NULL){
			fprintf(debug_file,"\t last_bottom_chan %s\n",
				channel->last_bottom_chan_link->channel->name);
		}
	}
	return(OK);
}
