/*   chan_net_com.c
 *
 *   Author:     Umakanta Choudhury
 *   Date:       15 July 1989
 *   Last modified:  Enrico Malavasi,  Aug. 1992
 *
 *   Purpose: 	Compute the common span between a channel and
 *              the maximum span of a net
 */
#include <stdio.h>
#include "layout.h"

float
  chan_net_com(chan, net)
struct	Channel *chan;
struct	Net     *net;
{
    float	max_common_span;
    float	left;
    float	right;
    
    left = MAX(net->max_span_left, chan->bottom);
    right = MIN(net->max_span_right, chan->top);
    max_common_span =  (right < left) ? 0 : (right-left);
    
    return max_common_span;
}
