/*		CREATE A FILE CONTAINING NODE INFO
*		----------------------------------
*
*   File:	create_node_file.c
*   Author: Umakanta Choudhury
*   Date:   27 Aug 91
*
*/
extern int strcmp();

#include <stdio.h>
#include "circuit.h"
#include "macros.h"

void
  create_node_file(circuit)
struct Circuit *circuit; /* The circuit structure */
{
    FILE *text_file; 
    struct Node *node;
    char filename[50];


    /* Open the text file */
    sprintf(filename,"%s_%d","/tmp/parcar.senscalc_nodes",getpid());
    if( (text_file = fopen(filename,"w")) == NULL) {
        fprintf(stderr, "\nE: could not open file %s",filename);
	exit( -1 );
    }
    fprintf(text_file,"num_nodes %d out_node1 %s out_node2 %s simulator %s\n",
	    circuit->num_nodes,circuit->out_node1_name,
	    circuit->out_node2_name,circuit->sim_name);
    
    for(node = circuit->node_list; node != NULL; 
        node = node->next) {
        fprintf(text_file,"%s\n",node->name);
    }

    fclose(text_file);
}
