/*      ds_enquire.c
 *
 *   File:       ds_enquire.c
 *   Author:     Umakanta Choudhury 
 *   Date:       18th June 1989
 *   Last modified:  Enrico Malavasi,  Aug. 1992
 *
 *   Purpose: Enquire about data structures. 
 */

#include <stdio.h>
#include <string.h>
#include "circuit.h"
#include "layout.h"
#include "avl.h"

int
  ds_FindChanInfoListLink(nameA, nameB, chan_info_list_link_ptr, layout)
char *nameA, *nameB; 
struct Chan_info_list_link **chan_info_list_link_ptr;
struct Layout *layout;
/*   Return YES if there is a channel_info_list_link structure  
 *   in the layout corresponding to a net pair  */
{
    struct Chan_info_list_link *chan_info_list_link;
    struct Chan_info *chan_info;
    
    for(chan_info_list_link=layout->chan_info_list_link ; chan_info_list_link!=NULL ; 
	chan_info_list_link = chan_info_list_link->next) {
	if((chan_info = chan_info_list_link->chan_info_list) != NULL) {
	    if(((strcmp(chan_info->netA->name,nameA) == 0) &&
		(strcmp(chan_info->netB->name,nameB) == 0)) ||
	       ((strcmp(chan_info->netA->name,nameB) == 0) &&
		(strcmp(chan_info->netB->name,nameA) == 0))) {
		/*   EUREKA   */
		*chan_info_list_link_ptr = chan_info_list_link;
		return YES;
	    }
	}
    }
    return  NO;
}


struct Net *
  rr_dsFindNet(net_name,channel)
char *net_name;
struct Channel *channel;
/*   Look in the net binary tree for the named net. Return pointer
 *  if it already exists. Make a new net otherwise.  */
{
    struct Net *rr_dsMakeNet();
    struct Net *net = NULL;
    
    /* Get/create the net */
    if(avl_lookup(channel->net_tree, net_name, &net) == 0) {
	net = rr_dsMakeNet(net_name,channel);
    }
    return net;
}

