/*      ROUTINE FOR FINDING A STORED LINK 
*       IN THE "pos_sens_stored_link" AND "neg_sens_stored_link"
*		LISTS OF A PERFORMANCE FUNCTION 
*       --------------------------------
*
*   File:       find_stored_link.c
*   Author:     Umakanta Choudhury
*   Date:       30th June 1989
*
*
*/

#include <stdio.h>
#include "circuit.h"
#include "layout.h"

extern int strcmp();

struct Sens_link  *find_stored_link(perf,nameA,nameB)
struct	Performance *perf;
char	*nameA;
char	*nameB;
{

	struct	Sens_link	*sens_link;

	for(sens_link = perf->pos_sens_stored_list; sens_link != NULL; 
		sens_link = sens_link->next){
		if( (strcmp(sens_link->nodeA->name,nameA) == 0) &&
			(strcmp(sens_link->nodeB->name,nameB) == 0)){
			/* found the link */
			return(sens_link);
		}
		/* try the reverse order */
		if( (strcmp(sens_link->nodeA->name,nameB) == 0) &&
			(strcmp(sens_link->nodeB->name,nameA) == 0)){
			/* found the link */
			return(sens_link);
		}
	}
	for(sens_link = perf->neg_sens_stored_list; sens_link != NULL; 
		sens_link = sens_link->next){
		if( (strcmp(sens_link->nodeA->name,nameA) == 0) &&
			(strcmp(sens_link->nodeB->name,nameB) == 0)){
			/* found the link */
			return(sens_link);
		}
		/* try the reverse order */
		if( (strcmp(sens_link->nodeA->name,nameB) == 0) &&
			(strcmp(sens_link->nodeB->name,nameA) == 0)){
			/* found the link */
			return(sens_link);
		}
	}
#ifdef DEBUG
	printf("find_stored_link: link (%s,%s) not found\n",nameA,nameB);
#endif 
	return(NULL);
}
