/*		ROUTINE FOR ESTIMATING MAXIMUM AND
*		MINIMUM CROSSOVER CAPACITANCES BETWEEN 
*		TWO NETS DUE TO FLOATING PINS IN COMMON SPAN 
*       -------------------------------------------
*
*   File:       flpin_cross.c
*   Author:     Umakanta Choudhury
*   Date:       16 July 1989
*
*
*/

#include <stdio.h>
#include "layout.h"

extern int strcmp();
extern double cap_cross();


REPORT flpin_cross(chan_info,chan,chan_edge)
struct 	Chan_info *chan_info;
struct 	Channel *chan;
int		chan_edge;
{
	struct Net *net1;
	struct Net *net2;
	struct NetLink *list;
	double W1; /* width of net1 */
	double W2; /* width of net2 */
	double cap; 

	net1 = chan_info->netA;
   	net2 = chan_info->netB;
	W1 = 2*(net1->true_half_width);
	W2 = 2*(net2->true_half_width);

	if(chan_edge == TOP){

		list = chan->left_crosses;
		if(net_present(list,net1) == YES){
			cap = cap_cross(W2,W1); 
			chan_info->Ccross_2above1 += cap;
		}
		if(net_present(list,net2) == YES){
			cap = cap_cross(W1,W2); 
			chan_info->Ccross_1above2 += cap;
		}
	}
	else{

		list = chan->right_crosses;
		if(net_present(list,net1) == YES){
			cap = cap_cross(W2,W1); 
			chan_info->Ccross_1above2 += cap;
		}
		if(net_present(list,net2) == YES){
			cap = cap_cross(W1,W2); 
			chan_info->Ccross_2above1 += cap;
		}
	}

	return(OK);
}
