/*	MACRO DEFINITIONS
	----------------------------

File: macros.h

Nicholas Weiner and Umakanta Choudhury,  18th March 1988
*/
#ifndef __MACROS_HEADER__
#define __MACROS_HEADER__

typedef int REPORT;
#define OK 0
#define ERROR -1
#define WARNING 1

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef HUGE
#define HUGE 10e6
#endif

#define NORMAL 0
#define CHANNEL_ROUTING 1

#define CIRCUIT 0
#define SENS 1

#ifdef NEW
#define STANDARD  0
#define NONSTANDARD 1
#endif NEW

#define POS_LIST 1
#define NEG_LIST -1
#define BOTH_LISTS 0
#define NEG_LIST -1
/* #define ALLOC(x) (( x *)malloc(sizeof(x))) */

#define FABS(x) ((x)>0.0)?(x):(-(x))

#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b) (((a)>(b))?(a):(b))
#endif

#define  SWAP(t,a,b)      {t x; x=a;a=b;b=x; }

#define MIN3(a,b,c) MIN( (MIN((a),(b))) , (c) )
#define MAX3(a,b,c) MAX( (MAX((a),(b))) , (c) )

/* Intersect - Evaluates TRUE if the (closed) intervals [l1,r1] and [l2,r2]
   intersect. Evaluates FALSE otherwise. */
#ifndef INTERSECT
#define INTERSECT(l1,r1,l2,r2) (((l1)>(r2))? FALSE : ((l2)>(r1))? FALSE: TRUE)
#endif

#define  FOPEN(x,n,m)    if((x=fopen(n,m))==NULL){\
	   fprintf(stderr,"** ERROR: Couldn't open file %s", n);\
	     exit(-1);}
#define  FCLOSE(x)       fclose(x)

/*  Output format flags  */
extern unsigned int output_format;
#define  BOUND_FORMAT   0x0001
#define  WEIGHT2_FORMAT (0x0001<<1)
#define  SENS_FORMAT    (0x0001<<2)

extern unsigned int verbose_flag;
extern unsigned int debug_flag;
#define VERBOSE(fct)   (verbose_flag)?fct:0
#define DEBUGG(fct)    (debug_flag)?fct:0

#define FEMTO_TO_FARAD(x)  ((x)*1.0e-15)
#define FARAD_TO_FEMTO(x)  ((x)*1.0e15)
#define MICRON_TO_METER(x) ((x)*1.0e-6)
#define METER_TO_MICRON(x) ((x)*1.0e6)

#endif
