/*		"PIECE-WISE CONSTANT" HEADER
*		----------------------------
*
*   File:	pwc.h
*   Author:	Nicholas Weiner
*   Date:	29th May 1989.
*
*/

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

typedef int PWC_REPORT;
#define PWC_OK 0
#define PWC_ERROR -1

#ifndef INTERSECT
#define INTERSECT(l1,r1,l2,r2) (((l1)>(r2))? FALSE : ((l2)>(r1))? FALSE:TRUE)
#endif

#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b) (((a)>(b))?(a):(b))
#endif


typedef char *PWC_POINTER;

extern struct PWC *pwcInit();
extern PWC_REPORT pwcAddRectangle(); 
extern PWC_REPORT pwcAddStep();  
extern PWC_REPORT pwcGenerateFunction();
extern PWC_REPORT pwcGetSteps();
extern PWC_REPORT pwcGetInvertval(); 
extern PWC_REPORT pwcMaxValue(); 
extern struct PWC *pwcMultiplyFunctions();
extern struct PWC *pwcAddFunctions();
extern PWC_REPORT pwcDeleteFunction();


struct PWC {
	char *name;			/* Function name. Diagnostic only. */
	float  left, right;		/* Range of function		   */
	struct StepLink *step_list;     /* Discontinuities                 */
	struct IntervalLink *interval_list;/* Derived from step list       */
	int    generated;		/* TRUE if function generated      */ 
	};

struct StepLink {
	struct StepLink *prev, *next;
        float  position;
	float size;
	};

struct IntervalLink {
	struct IntervalLink *prev, *next;
        float  left, right;
	float value;
	};
