/*
 */ 

#include <stdio.h> 
#include "oct.h"
#include "macros.h"
#include "layout.h"
#include "th.h"
#include "pep.h"

void
  techInit( techName )
char *techName;
{
    thTechnology( NULL );
}

double
  cap_cross( w1, w2 )
double w1;
double w2;
{
    double cap, pepModCrossing();

    cap = pepModCrossing( (octCoord) (20*w1), (octCoord) (20*w2), NULL, NULL );
    return FARAD_TO_FEMTO( cap );
}

double
  cap_parallel(w1, w2, s, LAYER)
double w1; /* width of segment1 */
double w2; /* width of segment2 */
double s; /* separation between the segments; 
	   * when LAYER is XY_LAYER that is
	   * segment1 is in x layer and segment2
	   * is in y layer "s12" is the distance
	   * between center lines of the 
	   * two segments 
	   */
int LAYER; /* layer information :X_LAYER,Y_LAYER or XY_LAYER*/
{
    double cap;
    double s_inv;
    double sw1_inv;
    double sw2_inv;



    if(s != 0) s_inv = 1/s;
    else {
	printf("cap_parallel.c : s cannot be zero\n");
	exit(-1);
    }
    if(s > 50) return(0);
    if(w1 !=0) sw1_inv = 1/(s+w1);
    else {
	printf("cap_parallel.c : w1 cannot be zero\n");
	exit(-1);
    }
    if(w2 !=0) sw2_inv = 1/(s+w2);
    else {
	printf("cap_parallel.c : w2 cannot be zero\n");
	exit(-1);
    }
    
    /* compute the polynomial (quadratic in s_inv and and linear in
       sw1_inv and sw2_inv ) */
    
    if(LAYER == X_LAYER){
	cap = -0.0048 +
	  (-0.023 * sw1_inv) +
	  (-0.023 * sw2_inv) +
	  (0.106  * s_inv) +
	  (-0.032 * s_inv * s_inv);
	return(cap);
    }
    else if(LAYER == Y_LAYER){
	cap = -0.0066 +
	  (-0.011 * sw1_inv) +
	  (-0.011 * sw2_inv) +
	  (0.115 * s_inv) +
	  (-0.037 * s_inv * s_inv);
	return(cap);
    }
    else{
	printf("illegal layer name\n");
	exit(-1);
    }
}
