/*      ORDER THE CHANNELS ALONG THE TOP AND BOTTOM EDGES OF THE CHANNEL
*       ------------------------------------------------------------
*
*   File:       order_chans.c
*   Author:     Umakanta Choudhury
*   Date:       11th July 1988
*
*   Utility to order linear linked lists of channels.
*   Uses Richard Rudell's linked list sorting package.
*/

#include <stdio.h>
#include "layout.h"

#define TYPE struct ChannelLink
#define SORT1 rrCountAndLSortChans
#define SORT rrLSortChans
#define FIELD channel->bottom
#define DIRECT_COMPARE
#define NOT_NEEDED 0
#include "lsort.h"


/*
* ORDER CHANNELS IN LIST ACCORDING TO HORIZONTAL POSITION
*
* Returns OK.
*/
REPORT
  order_chans(chan_list_ptr,last_ptr)
struct ChannelLink **chan_list_ptr;
struct ChannelLink **last_ptr;
{
    struct ChannelLink *chan_link, *prev_link;
    
    *chan_list_ptr = rrCountAndLSortChans(*chan_list_ptr,NOT_NEEDED);
    
    /* Rudell's routines only change the "next" pointers. 
       Still have to do the "prev" pointers. and set the last ptr*/

    if(*chan_list_ptr == NULL) *last_ptr = NULL;
    prev_link = NULL;
    for(chan_link=(*chan_list_ptr);chan_link!=NULL;chan_link=chan_link->next) {
	chan_link->prev = prev_link;
	prev_link = chan_link;
	if(chan_link->next == NULL) *last_ptr = chan_link;
    }
    
    return OK;
}
