/*      ORDER THE PINS ALONG THE TOP AND BOTTOM EDGES OF THE CHANNEL
*       ------------------------------------------------------------
*
*   File:       order_pins.c
*   Author:     Nicholas Weiner
*   Date:       29th March 1988
*
*   Utility to oreder linear linked lists of pins.
*   Uses Richard Rudell's linked list sorting package.
*/

#include <stdio.h>
#include "layout.h"

#define TYPE struct PinLink
#define SORT1 rrCountAndLSortPins
#define SORT rrLSortPins
#define FIELD pin->x_position
#define DIRECT_COMPARE
#define NOT_NEEDED 0
#include "lsort.h"


/*
* ORDER PINS IN LIST ACCORDING TO HORIZONTAL POSITION
*
* Returns OK.
*/
REPORT order_pins(pin_list_ptr,last_ptr)
struct PinLink **pin_list_ptr;
struct PinLink **last_ptr;
{
    struct PinLink *pin_link, *prev_link;

    *pin_list_ptr = rrCountAndLSortPins(*pin_list_ptr,NOT_NEEDED);
    
    /* Rudell's routines only change the "next" pointers. 
       Still have to do the "prev" pointers and set the last ptr*/


    if (*pin_list_ptr == NULL) *last_ptr = NULL;
    prev_link = NULL;
    for(pin_link=(*pin_list_ptr);pin_link!=NULL;pin_link=pin_link->next) {
	pin_link->prev = prev_link;
	prev_link = pin_link;
	if(pin_link->next == NULL) *last_ptr = pin_link;
    }

    return OK;
}
