/*      ORDER THE PINS ALONG THE TOP AND BOTTOM EDGES OF THE CHANNEL
*       ------------------------------------------------------------
*
*   File:       orderpins.c
*   Author:     Nicholas Weiner
*   Date:       29th March 1988
*
*   Utility to oreder linear linked lists of pins.
*   Uses Richard Rudell's linked list sorting package.
*/

#include <stdio.h>
#include "layout.h"

#define TYPE struct Crit_temp
#define SORT1 sens_sort2
#define SORT sens_sort1
#define FIELD sens
#define DIRECT_COMPARE
#define NOT_NEEDED 0
#include "lsort.h"


/*
* ORDER PINS IN LIST ACCORDING TO HORIZONTAL POSITION
*
* Returns OK.
*/
REPORT
  sens_order(crit_temp_list)
struct Crit_temp **crit_temp_list;
{
    struct Crit_temp *crit_temp, *prev_crit_temp;
    
    *crit_temp_list = sens_sort2(*crit_temp_list,NOT_NEEDED);
    
    /* Rudell's routines only change the "next" pointers. Still have to do
       the "prev" pointers. */
    prev_crit_temp = NULL;
    for(crit_temp=(*crit_temp_list) ; crit_temp!=NULL ; crit_temp=crit_temp->next) {
	crit_temp->prev = prev_crit_temp;
	prev_crit_temp = crit_temp;
    }
    
    return OK;
}
