/*  sens_range.c
 *
 *   Author:     Umakanta Choudhury
 *   Date:       18th October 1989
 *   Last modified:  Enrico Malavasi,  Aug. 1992
 *
 *   Purpose: Compute worst-case sensitivities w.r.t. matched parasitics
 */
#include <stdio.h>
#include <macros.h>


REPORT sens_range(sens1, sens2, r_max, r_mis, max_ptr, min_ptr)
float sens1;
float sens2;
float r_max;
float r_mis;
float *max_ptr;
float *min_ptr;
{
    
    float sens0; 
    float abs_sens1; 
    float abs_sens2; 
    
    DEBUGG(printf("sens_range\n"));
    
    sens0 = sens1 + sens2;
    if((sens1 >= 0) && (sens2 >= 0)){
	/* when both sensitivities are positive */
	*max_ptr = (1 + r_max)*sens0;
	*min_ptr = (1 - r_max)*sens0;
    }
    else if ((sens1 < 0) && (sens2 < 0)){
	/* when both sensitivities are negative */
	*max_ptr = (1 - r_max)*sens0;
	*min_ptr = (1 + r_max)*sens0;
    }
    else{
	/* when the sensitivities are of opposite sign */
	/* take the absolute values of sensitivities */
	abs_sens1 = FABS(sens1);
	abs_sens2 = FABS(sens2);
	
	if(abs_sens1 = abs_sens2){
	    /* sens0 is "0" in this case */
	    *max_ptr = sens0 + r_mis * abs_sens1;
	    *min_ptr = sens0 - r_mis * abs_sens1;
	}
	else if(abs_sens1 < abs_sens2){
	    *max_ptr = sens0 + r_max*(abs_sens2 - abs_sens1) + r_mis*abs_sens1;
	    *min_ptr = sens0 - r_max*(abs_sens2 - abs_sens1) - r_mis*abs_sens1;
	}
	else {
	    *max_ptr = sens0 + r_max*(abs_sens1 - abs_sens2) + r_mis*abs_sens2;
	    *min_ptr = sens0 - r_max*(abs_sens1 - abs_sens2) - r_mis*abs_sens2;
	}
    }
    return(OK);
}
