/*   sens_sort.c
 *
 *   Author:     Nicholas Weiner
 *   Modified by:  Umakanta Choudhury
 *   Date:       3rd July 1989
 *   Last modified:  Enrico Malavasi,  Aug. 1992
 *
 *   Purpose: Order the sensitivities
 *            It uses Richard Rudell's linked list sorting package.
 */
#include <stdio.h>
#include "layout.h"
#include "circuit.h"

#define TYPE struct Sens_link
#define SORT1 sens_sort4
#define SORT sens_sort3
#define FIELD sens
#define DIRECT_COMPARE
#define NOT_NEEDED 0
#include "lsort.h"

REPORT
  sens_sort(sens_link_list_ptr)
struct Sens_link **sens_link_list_ptr;
{
    struct Sens_link *sens_link, *prev_sens_link;
    
    *sens_link_list_ptr = sens_sort4(*sens_link_list_ptr, NOT_NEEDED);
    
    /* Rudell's routines only change the "next" pointers. 
       Still have to do the "prev" pointers. */
    
    prev_sens_link = NULL;
    for(sens_link=(*sens_link_list_ptr); sens_link!=NULL ; sens_link=sens_link->next) {
	sens_link->prev = prev_sens_link;
	prev_sens_link = sens_link;
    }
    
    return OK;
}
