
WRD   [a-zA-Z0-9\.\+\-\/]+

%%

(b|B)(e|E)(g|G)(i|I)(n|N)                            return pcrBegin(yytext);
(c|C)(h|H)(a|A)(n|N)(n|N)(e|E)(l|L)                  return pcrChannel(yytext);
(d|D)(e|E)(c|C)(k|K)(f|F)(i|I)(l|L)(e|E)             return pcrDeckfile(yytext);
(e|E)(n|N)(d|D)                                      return pcrEnd(yytext);
(i|I)(g|G)(n|N)(o|O)(r|R)(e|E)                       return pcrIgnore(yytext);
(l|L)(a|A)(y|Y)(o|O)(u|U)(t|T)                       return pcrLayout(yytext);
(m|M)(a|A)(t|T)(c|C)(h|H)(n|N)(o|O)(d|D)(e|E)(s|S)   return pcrMatchNodes(yytext);
(m|M)(a|A)(x|X)(v|V)(a|A)(r|R)                       return pcrMaxvar(yytext);
(m|M)(i|I)(s|S)(m|M)(a|A)(t|T)(c|C)(h|H)             return pcrMismatch(yytext);
(n|N)(a|A)(m|M)(e|E)                                 return pcrName(yytext);
(o|O)(u|U)(t|T)(n|N)(o|O)(d|D)(e|E)(s|S)             return pcrOutNodes(yytext);
(p|P)(e|E)(r|R)(f|F)(o|O)(r|R)(m|M)(a|A)(n|N)(c|C)(e|E) return pcrPerformance(yytext);
(r|R)(a|A)(n|N)(g|G)(e|E)                            return pcrRange(yytext);
(s|S)(i|I)(m|M)(u|U)(l|L)(a|A)(t|T)(i|I)(o|O)(n|N)   return pcrSimulation(yytext);
(s|S)(i|I)(m|M)(u|U)(l|L)(a|A)(t|T)(o|O)(r|R)        return pcrSimulator(yytext);
(t|T)(e|E)(c|C)(h|H)(n|N)(o|O)(l|L)(o|O)(g|G)(y|Y)   return pcrTechnology(yytext);
(v|V)(a|A)(r|R)(i|I)(a|A)(t|T)(i|I)(o|O)(n|N)        return pcrVariation(yytext);
\+|\-                                                return pcrSign(yytext);
\[|\]                                                return pcrSquare(yytext);
\(|\)                                                return pcrRound(yytext);
\,                                                   return pcrComma(yytext);
^\!.*\n             ;
{WRD}                      return pcrWord(yytext);
[, \t\n]            ;

%%
#include "y.tab.h"


pcrSquare( s )
char *s;
{     return ((s[0]=='[')? OPEN_SQUARE : CLOSE_SQUARE);  }

pcrRound( s )
char *s;
{     return ((s[0]=='(')? OPEN_ROUND : CLOSE_ROUND);  }

pcrBegin( s )
char *s;
{     return BGN;  }

pcrIgnore( s )
char *s;
{     return IGNORE;  }

pcrComma( s )
char *s;
{     return COMMA;  }

pcrEnd( s )
char *s;
{     return END;  }

pcrDeckfile( s )
char *s;
{     return DECKFILE;  }

pcrSimulation( s )
char *s;
{     return SIMULATION;  }

pcrVariation( s )
char *s;
{     return VARIATION;  }

pcrMismatch( s )
char *s;
{     return MISMATCH;  }

pcrTechnology( s )
char *s;
{     return TECHNOLOGY;  }

pcrLayout( s )
char *s;
{     return LAYOUT;  }

pcrChannel( s )
char *s;
{     return CHANNEL;  }

pcrName( s )
char *s;
{     return NAME;  }

pcrRange( s )
char *s;
{     return RANGE;  }

pcrMatchNodes( s )
char *s;
{     return MATCHNODES;  }

pcrOutNodes( s )
char *s;
{     return OUTNODES;  }

pcrSimulator( s )
char *s;
{    return SIMULATOR; }

pcrPerformance( s )
char *s;
{    return PERFORMANCE; }

pcrMaxvar( s )
char *s;
{    return MAXVAR; }

pcrWord( s )
char *s;
{
    return WORD;
}
pcrSign( s )
char *s;
{   return ((s[0]=='-') ? MINUS : PLUS); }

pcrNumber( s )
char *s;
{    return NUMBER; }

pcrEqual()
{
    return EQUAL;
}


yyerror( s )
char *s;
{
    fprintf(stderr, s);
    exit( -1 );
}

yyopenfile( fileName )
char *fileName;
{
    if((yyin=fopen( fileName, "r" )) == NULL) {
	fprintf(stderr, "%s: file not found\n", fileName);
	exit( -1 );
    }
}
