/*      ROUTINE FOR TRANSFORMING  
*		THE COORDINATES OF CHANNELS
*		ORIENTED TOP-BOTTOM
*       ---------------------------------------
*
*   File:       trans_chan.c
*   Author:     Umakanta Choudhury
*   Date:       6th July 1989
*
*
*/

#include <stdio.h>
#include "layout.h"
#include "circuit.h"



REPORT
  trans_chan(layout)
struct Layout *layout;
{
    struct	Channel *channel;
    struct	ChannelLink *chan_link;
    struct	PinLink *pin_link;
    struct	Pin	*pin;
    float	left;
    float	right;
    float	bottom;
    float	top;
    float	x_pos;
    float	y_pos;
	
	
    for(chan_link = layout->chan_list; chan_link != NULL; 
	chan_link = chan_link->next){
	channel = chan_link->channel;
	if(channel->orient == LEFT_RIGHT){
	    /* transform the edges */
	    /* left->bottom; right->top; bottom->left; top->right */
	    
	    bottom = channel->bottom;
	    top = channel->top;
	    left = channel->left;
	    right = channel->right;
	    
	    channel->left = bottom;
	    channel->right = top;
	    channel->bottom = left;
	    channel->top = right;
	    
	    /* transform the pin coordinates */
	    
	    for(pin_link = channel->left_pins; pin_link != NULL;
					pin_link = pin_link->next){
		pin = pin_link->pin;
				x_pos = pin->x_position;
		pin->x_position = pin->y_position;
		pin->y_position = x_pos;
		pin->edge = BOTTOM;
	    }
	    channel->bottom_pins = channel->left_pins;
	    channel->num_bottom_pins = channel->num_left_pins;
	    
	    for(pin_link = channel->right_pins; pin_link != NULL;
		pin_link = pin_link->next){
		pin = pin_link->pin;
		x_pos = pin->x_position;
		pin->x_position = pin->y_position;
		pin->y_position = x_pos;
		pin->edge =TOP;
	    }
	    
	    channel->top_pins = channel->right_pins;
	    channel->num_top_pins = channel->num_right_pins;
	    
	    channel->left_crosses = channel->bottom_crosses;
	    channel->num_left_crosses = channel->num_bottom_crosses;
			channel->right_crosses = channel->top_crosses;
	    channel->num_right_crosses = channel->num_top_crosses;
	}
    }
    return OK;
}
