/*
 *  FILE: nleInstSubs.c
 *
 *  DESCRIPTION:
 *
 *
 *  CREATION DATE: xx/xx/xx		AUTHOR:
 *
 *  FUNCTIONS:
 * checkArgsInstSubs(spot, cmdList)
 * rpcInstSubs(chip, nName, InstBagP)
 * 
 */
#include "rpc.h"
#include "nle.h"

/* >>> GLOBAL VARIABLES */

char 	    *RPCstrsave();

RPCArg    *gArg1, *gArg2;

/*
 */
rpcInstSubs(spot, cmdList , userOptionWord)
    RPCSpot	*spot;
    lsList 	cmdList;
    long 	userOptionWord;
{
  octObject 	Chip;
  char 		*newViewName;
  octObject 	OldInstance;
  octObject 	NewInstance;
  octObject 	iBag;
  struct octBox redrawBox;
  
  if (checkArgsInstSubs(spot, cmdList) != NLE_OK) return(RPC_OK);

  Chip.objectId = spot->facet;
  if (octGetById(&Chip)!=OCT_OK) FatalError("getting facet");

  iBag.objectId = gArg1->argData.objArg.theBag;
  newViewName = RPCstrsave(gArg2->argData.string);
  octGetById(&iBag);
  
  if (octGenFirstContent(&iBag,OCT_INSTANCE_MASK,&OldInstance)!=OCT_OK) {
    vemMessage("No instance");
    return(RPC_OK);
  }
  NewInstance.contents.instance.view = newViewName;

  vemMessage("Replacing Instance View ...\n", MSG_DISP|MSG_NOLOG);
 
  if (nleModifyInstanceView(&OldInstance, &NewInstance) != NLE_OK) {
    vemMessage("Modification failed\n", MSG_DISP|MSG_NOLOG);
    return(RPC_OK);
  }
  vemMessage("Modification done\n", MSG_DISP|MSG_NOLOG);

  /*
   * Redisplay chip and open a window on the new cell
   */
  if (octBB(&NewInstance,&redrawBox)!=OCT_OK) {
    Warning("No bounding box in the new instance\n");
  } else {
    vemWnQRegion(&Chip,&redrawBox);
    vemWnFlush();
  }

  return(RPC_OK);
}


rpcInstSubsUsage()
{
  vemMessage("format: [selected instance] \"new-view-name\" : change-view\n", MSG_DISP|MSG_NOLOG);
}



checkArgsInstSubs(spot, cmdList)
     RPCSpot *spot;
     lsList cmdList;
{
  octObject Facet;
  
  if (lsLength(cmdList) != 2) {
    rpcInstSubsUsage();
    return(NLE_NOT_OK);
  }
  Facet.objectId = spot->facet;
  if (octGetById(&Facet) != OCT_OK) {
    Warning("Could not find facet");
    return(NLE_NOT_OK);
  }
  lsDelBegin(cmdList, (Pointer *) &gArg1);
  if (gArg1->argType != VEM_OBJ_ARG) {
    rpcInstSubsUsage();
    return(NLE_NOT_OK);
  }
  lsDelBegin(cmdList, (Pointer *) &gArg2);
  if (gArg2->argType != VEM_TEXT_ARG) {
    rpcInstSubsUsage();
    return(NLE_NOT_OK);
  }
  return(NLE_OK);
}





