/*
 * GetPvPc gets the sensitivity infomation(pvmpc, pvppc) from a SPICE output file
 *  
 */ 


#include <stdio.h>
#include <math.h>
#include "formulate.h"
#include "macros.h"

#define name1 (*(*node_names_ptr + i))
#define name2 (*(*node_names_ptr + j))
#define out_node1 (*(*node_names_ptr + num_nodes + 1))
#define out_node2 (*(*node_names_ptr + num_nodes + 2))


GetPvPc(spiceinf,data_point,mode,node_names_ptr,num_nodes,sim_data)
char *spiceinf;
double data_point; /* frequency or time point where simulation has to be performed */
int mode; /* DC, AC or TRAN */ 
char ***node_names_ptr;
int num_nodes; 
SIM_data sim_data;


{
    FILE *in_file1;
    FILE *in_file2;
    FILE *in_file3;
    FILE *in_file4;
    FILE *out_file1;
    FILE *out_file2;
    FILE *temp_file1;
    FILE *temp_file2;
    int *node1_index_list;
    int *node2_index_list;
    int num_params;
    int max_num_params;
    int max_inp_line_length;
    int i;
    int j;
    int line_length;
    int length1;
    int length2;
    int num_entries = 0;
    int num_mag_entries = 0;
    int num_ph_entries = 0;
    int out_mode = 0;
    char out1_file_name[30]; 
    char out2_file_name[30]; 
    char out_file_name[30]; 
    char ext1_file_name[30]; 
    char ext2_file_name[30]; 
    char ext3_file_name[30]; 
    char ext4_file_name[30]; 
    char temp_file_name[30]; 
    char temp1_file_name[30]; 
    char temp2_file_name[30]; 
    char ckt_file_name[30]; 
    char ckt_in_file_name[30]; 
    char ckt_out_file_name[30]; 
    char command[100]; 


    int *mode_ptr; /* DC, AC or TRAN */ 
    max_num_params = 1000;
    max_inp_line_length = 70;

    GetPvPcPrep(spiceinf);

    node1_index_list = MNALLOC((max_num_params+1),int);
    node2_index_list = MNALLOC((max_num_params+1),int);
    /*
      data_point = MALLOC(double);
      if((mode_ptr = (int *)malloc(sizeof(int))) == NULL) 
      print_error("out of memory\n");

    if(node_read("node.in",node_names_ptr,&(num_nodes),
		 mode,data_point) != OK){
	print_error("main.c: error in node_read()\n");
    }
      */

    sprintf(ckt_in_file_name,"%s_%d","/tmp/parcar.ckt.in",getpid()); 
    sprintf(ckt_out_file_name,"%s_%d","/tmp/parcar.ckt.out",getpid()); 

    sprintf(out1_file_name,"%s_%d","/tmp/parcar.outfile1",getpid()); 
    out_file1 = fopen(out1_file_name,"w");
    sprintf(out2_file_name,"%s_%d","/tmp/parcar.outfile2",getpid()); 
    out_file2 = fopen(out2_file_name,"w");
    sprintf(out_file_name,"%s_%d","/tmp/parcar.outfile",getpid()); 
    sprintf(ext1_file_name,"%s_%d","/tmp/parcar.ext1",getpid()); 
    in_file1 = fopen(ext1_file_name,"w");
    sprintf(ext2_file_name,"%s_%d","/tmp/parcar.ext2",getpid()); 
    in_file2 = fopen(ext2_file_name,"w");
    sprintf(ext3_file_name,"%s_%d","/tmp/parcar.ext3",getpid()); 
    in_file3 = fopen(ext3_file_name,"w");
    sprintf(ext4_file_name,"%s_%d","/tmp/parcar.ext4",getpid()); 
    in_file4 = fopen(ext4_file_name,"w");
    sprintf(temp_file_name,"%s_%d","/tmp/parcar.temp",getpid()); 
    sprintf(temp1_file_name,"%s_%d","/tmp/parcar.temp1",getpid()); 
    sprintf(temp2_file_name,"%s_%d","/tmp/parcar.temp2",getpid()); 

    fclose(out_file1);
    fclose(out_file2);

	if(strcmp(out_node1,"0") == 0) out_mode = OUT1_ZERO; 
	else if(strcmp(out_node2,"0") == 0) out_mode = OUT2_ZERO; 
   	else out_mode = NORMAL; 

#ifdef DEBUG
	printf("out_mode = %d\n",out_mode);
#endif

    if(mode == DC) {
	print_error("main.c:DC mode not implemented yet\n");
    }
    else if(mode == AC) {
	fprintf(in_file1,"\n.SENS ac");
    }
    else if (mode == TRAN){
	fprintf(in_file1,"\n.SENS tran ");
    }
    else {
	print_error("main.c:unknown mode\n");
    }

    line_length = 10;
    num_params = 0;

    for(i = 1; i <= num_nodes; i++){
	for(j = 1; j <= num_nodes; j++){
	    if(i < j){/* to avoid repeating the same combination */

		num_params++ ;
		*(node1_index_list + num_params) = i;
		*(node2_index_list + num_params) = j;

		length1 = strlen(name1);
		length2 = strlen(name2);
		line_length += 26 + length1 + length2;

		if(line_length > max_inp_line_length){
		    /* create a new .SENS card and print in that 
		       line */
		    fprintf(in_file1,"\n");

		    if(mode == DC){ 
			print_error("main.c: DC mode not implemented yet\n");;
		    }
		    else if(mode == AC){ 
			fprintf(in_file1,
				".SENS ac dev=c%s%s parm = sens_cap ",
				name1,name2);
		    }
		    else {
			fprintf(in_file1,
				".SENS tran dev=c%s%s parm = sens_cap ",
				name1,name2);
		    }

		    line_length = 10 + 26 + length1 + length2;
		}
		else{
		    /* print in the same line */
		    fprintf(in_file1," dev=c%s%s parm=sens_cap",
			    name1,name2);
		}
		fprintf(in_file2,"c%s%s %s %s 0.000p\n",
			(name1),(name2),(name1),(name2));
		if(mode == DC){ 
		    print_error("main.c: DC mode not implemented yet\n");;
		}
		else if(mode == AC){ 
			if(out_mode != OUT1_ZERO){
   		        fprintf(in_file3,
			        ".save \"@c%s%s[sens_real,%s]\"\n",
			        (name1),(name2),(out_node1));
		        fprintf(in_file3,
			        ".save \"@c%s%s[sens_imag,%s]\"\n",
    			    (name1),(name2),(out_node1));
			}
			if(out_mode != OUT2_ZERO){
		        fprintf(in_file3,
			        ".save \"@c%s%s[sens_real,%s]\"\n",
    			    (name1),(name2),(out_node2));
    		    fprintf(in_file3,
    			    ".save \"@c%s%s[sens_imag,%s]\"\n",
    			    (name1),(name2),(out_node2));
			}
			if(out_mode != OUT1_ZERO){
     		    fprintf(in_file4,
	     		    ".print ac \"@c%s%s[sens_real,%s]\"\n",
		     	    (name1),(name2),(out_node1));
	            fprintf(in_file4,
			        ".print ac \"@c%s%s[sens_imag,%s]\"\n",
     			    (name1),(name2),(out_node1));
			}
			if(out_mode != OUT2_ZERO){
 		        fprintf(in_file4,
			        ".print ac \"@c%s%s[sens_real,%s]\"\n",
			        (name1),(name2),(out_node2));
    		    fprintf(in_file4,
    			    ".print ac \"@c%s%s[sens_imag,%s]\"\n",
    			    (name1),(name2),(out_node2));
			}
		}
		else{ /* TRAN mode */
			if(out_mode != OUT1_ZERO){
		        fprintf(in_file3,
			        ".save \"@c%s%s[sens_real,%s]\"\n",
    			    (name1),(name2),(out_node1));
		        fprintf(in_file4,
			        ".print tran \"@c%s%s[sens_real,%s]\"\n",
			        (name1),(name2),(out_node1));
			}
			if(out_mode != OUT2_ZERO){
    		    fprintf(in_file3,
    			    ".save \"@c%s%s[sens_real,%s]\"\n",
    			    (name1),(name2),(out_node2));
		        fprintf(in_file4,
			        ".print tran \"@c%s%s[sens_real,%s]\"\n",
			        (name1),(name2),(out_node2));
			}
		}
		if((num_params >= max_num_params)||
		   ((i==(num_nodes - 1)) && (j==num_nodes))){
		    /* don't want to feed into spice more than 
		     * max_num_params at the same time 
		     */
		    fprintf(in_file1,"\n\n");
		    fprintf(in_file2,"\n");
		    fprintf(in_file3,"\n");
		    fprintf(in_file4,".end");
		    fclose(in_file1);
		    fclose(in_file2);
		    fclose(in_file3);
		    fclose(in_file4);
            sprintf(ckt_file_name,"%s_%d","/tmp/parcar.ckt",getpid()); 

		    sprintf(command,"cat %s %s > %s",ckt_file_name,
			    ext1_file_name,temp_file_name);
		    system(command);
		    sprintf(command,"cat %s %s > %s",temp_file_name,
			    ext2_file_name,ext1_file_name);
		    system(command);
		    sprintf(command,"cat %s %s > %s",ext1_file_name,
			    ext3_file_name,ext2_file_name);
		    system(command);
		    sprintf(command,"cat %s %s > %s",ext2_file_name,
			    ext4_file_name,ckt_in_file_name);
		    system(command);
/*		    sprintf(command,"rm %s",temp_file_name); */
/*		    system(command); */
/*		    sprintf(command,"rm %s",ext1_file_name); */
/*		    system(command); */
/*		    sprintf(command,"rm %s",ext2_file_name); */
/*		    system(command); */
/*		    sprintf(command,"rm %s",ext3_file_name); */
/*		    system(command); */
/*		    sprintf(command,"rm %s",ext4_file_name); */
/*		    system(command); */

            sprintf(command, " %s < %s >  %s",sim_name,
            ckt_in_file_name,ckt_out_file_name);

#ifdef DEBUG
		    printf("before spice in GetPvPc\n");
#endif
            system(command);

#ifdef DEBUG
		    printf("after spice in GetPvPc\n");
#endif
		    if(mode == DC){ 
			print_error("main.c: DC mode not implemented yet\n");;
		    }
		    else if(mode == AC){ 
    			if(sens_ac_read(ckt_out_file_name,*node_names_ptr,
					data_point,node1_index_list,node2_index_list,
					num_params,&num_mag_entries,
					&num_ph_entries,sim_data,out_mode) != OK)

			    print_error("main.c: error in sens_ac_read()\n");
		    }
		    else{ /* TRAN mode */
    			if(sens_tran_read(ckt_out_file_name,*node_names_ptr,
					  data_point,node1_index_list,node2_index_list,
					  num_params,&num_entries,sim_data,out_mode) != OK)

			    print_error("main.c: error in sens_tran_read()\n");
		    }
		    in_file1 = fopen(ext1_file_name,"w");
		    in_file2 = fopen(ext2_file_name,"w");
		    if(mode == DC){ 
			print_error("main.c: DC mode not implemented yet\n");;
		    }
		    else if(mode == AC){ 
			fprintf(in_file1,".SENS ac");
		    }
		    else{ /* TRAN mode */
			fprintf(in_file1,".SENS tran");
		    }
		    line_length = 10;
		    num_params = 0;
		}
	    }
	}
    }
    if(mode == DC){ 
	print_error("main.c: DC mode not implemented yet\n");;
    }
    else if(mode == AC){ 
    sprintf(temp1_file_name,"%s_%d","/tmp/parcar.temp1",getpid()); 
	temp_file1 = fopen(temp1_file_name,"w");
    sprintf(temp2_file_name,"%s_%d","/tmp/parcar.temp2",getpid()); 
	temp_file2 = fopen(temp2_file_name,"w");
	fprintf(temp_file1,
		"number of nonzero magnitude sensitivities = %d\n",
		num_mag_entries);
	fprintf(temp_file1,
		"! sensitivities in v/fF \n");
	fprintf(temp_file2,
		"number of nonzero phase sensitivities = %d\n",
		num_ph_entries);
	fprintf(temp_file2,"! sensitivities in deg/fF \n");
	fclose(temp_file1);
	fclose(temp_file2);
	sprintf(command,"cat %s %s > %s",temp1_file_name,
    out1_file_name,temp_file_name);

    system(command);
	sprintf(command,"cat %s %s > %s",temp_file_name,
    temp2_file_name,temp1_file_name);
    system(command);
	sprintf(command,"cat %s %s > %s",temp1_file_name,
    out2_file_name,out_file_name);
    system(command);
	sprintf(command,"rm %s %s %s %s %s",out1_file_name,out2_file_name,
		temp1_file_name,temp2_file_name,temp_file_name);
/*	system(command);  */
    }
    else{ /* TRAN mode */
    sprintf(temp1_file_name,"%s_%d","/tmp/parcar.temp1",getpid()); 
	temp_file1 = fopen(temp1_file_name,"w");
	fprintf(temp_file1,
		"number of nonzero transient sensitivities = %d\n",
		num_entries);
	fprintf(temp_file1,"! sensitivities in v/fF \n");
	fclose(temp_file1);
	sprintf(command,"cat %s %s > %s",temp1_file_name,
    out1_file_name,out_file_name);
    system(command);
    sprintf(command,"rm %s %s",out1_file_name,temp1_file_name);
    }
    return(OK);
}

/*
 *
 * 'GetPvPcPrep' takes a spice input filename as argument and
 * creates another temporary spice input file suitable for 
 * processing by 'GetPvPc'.  Essentially, all '.print', '.plot',
 * and '.end' statements are stripped, and the necessary '.sens'
 * cards are replaced.
 *
 */

#define MAX_SPICE_LINE		100

GetPvPcPrep(spiceinf)
char *spiceinf;
{
    FILE *ifile, *sensifile;
    FILE *fopen();

/*    char name[20];  */

    char *line;
    char *s;
    char filename[50];
    int lower(), pstrcmp();

    line = (char *) malloc(sizeof(char)*MAX_SPICE_LINE);
#ifdef DEBUG
printf("entering GetPvPcPrep()\n");
#endif
    ifile = fopen(spiceinf,"r");
/*    sprintf(name, "%s_sens",spiceinf);    */

    sprintf(filename,"%s_%d","/tmp/parcar.ckt",getpid()); 
    sensifile = fopen(filename, "w");

/*
printf("starting while loop\n");
*/

    while (fgets(line, MAX_SPICE_LINE, ifile) != NULL) {
	for (s=line; *s != '\0'; s++) {
	    *s = lower(*s);
	}
/*
printf("past for loop\n");
*/
/*	    *s = (isupper(*s) ? tolower(*s) : *s);   */
	if (pstrcmp(".print",line) == 0 || pstrcmp(".end",line) == 0 ||
	  pstrcmp(".plot",line) == 0) {
/*
printf("continuing\n");
*/
	  continue;
    	}
		/*
	else if (pstrcmp("*.print",line) == 0) {
	    line++;
	    fputs(line, sensifile);
	    line--;
	}
	*/
	else {
/*
printf("putting\n");
*/
	  fputs(line, sensifile);
	}
    }
    fclose(ifile);
    fclose(sensifile);
#ifdef DEBUG
printf("leaving GetPvPcPrep()\n");    
#endif
}	    

lower(c)   /* convert c to lower case; ASCII only */
int c;
{
    if (c >= 'A' && c <= 'Z')
   	return(c + 'a' - 'A');
    else
	return(c);
}

pstrcmp(s, t)   /* return 0 if s is part of t, nonzero is not */
char *s, *t;
{
    for ( ; *s == *t || *s == '\0'; s++, t++)
      if (*s == '\0')
	return(0);
    return(*s - *t);
}

