/*
 * node_read reads in the node.in file and stores all informations 
 * from the node.in file. It then appends the .sens ...
 * SPICE commands for all combination of the nodes at the end of 
 * the input spice deck.
 *
 */
#include <stdio.h>
#include <string.h>

extern int strcmp();
char *strsave( s )
char *s;
{
    char *p;
    p = (char *) calloc(strlen(s)+1, sizeof(char));
    strcpy( p, s );
    return p;
}

#include <stdio.h>
#include "macros.h"
#include "formulate.h"

#define MAX_LINE_LENGTH 200
#define PRINT_LINE_DATA {printf("%s: line %d\n",text_file_name,linenum);}

node_read(text_file_name,node_names_ptr,num_node_ptr)

char *text_file_name;		/* The input text file			*/
char ***node_names_ptr;
int *num_node_ptr;

{
    FILE	*text_file;
    char	text_line[MAX_LINE_LENGTH];
    int		linenum = 1;
	char    node_name[20];
	char    node_name1[20];
	char    node_name2[20];
	double value;
	int i;


	/* Open the text file */
	if( (text_file = fopen(text_file_name,"r")) == NULL) {
		printf("\nE: \"%s\" file not found.\n",text_file_name);
		return ERROR;
	}
	if(fgets(text_line,MAX_LINE_LENGTH,text_file) == NULL){
		printf("\nE: nothing in file \"%s\" \n",text_file_name);
		return ERROR;
	}


	if(sscanf(text_line,"num_nodes %d out_node1 %s out_node2 %s simulator %s\n",
		num_node_ptr,node_name1,node_name2,sim_name) == 4){
/*
	if(sscanf(text_line,"num_nodes %d out_node1 %s out_node2 %s\n",
		num_node_ptr,node_name1,node_name2) == 3){
*/


		*node_names_ptr = MNALLOC((*num_node_ptr + 3),char *);
		*(*node_names_ptr + *num_node_ptr + 1) = strsave( node_name1 );
		*(*node_names_ptr + *num_node_ptr + 2) = strsave( node_name2 );

		/*** ignore   *
		mode_name = mode;
		if(strcmp(mode_name,"DC") == 0){ 
			print_error("node_read.c: DC mode not implemented\n");
		}
		else if(strcmp(mode_name,"AC") == 0){ 
			*mode = AC;
		}
		else if(strcmp(mode_name,"TRAN") == 0){ 
			*mode = TRAN;
		}
		else{ 
			print_error("node_read.c: unknown mode\n");
		}
		****** ignore  ***/
	}
	else{
		PRINT_LINE_DATA;
		printf("first line must specify number of nodes \n");
		return ERROR;
	}

   	/* Read file, line by line */
	i = 0;
	for(linenum = 1; ;linenum++) {
		if(fgets(text_line,MAX_LINE_LENGTH,text_file) == NULL)
            break;
    
		/* Check for comment or empty line */
		if(text_line[0] == ';') continue;
		if(strlen(text_line) == 1) continue;

		if(sscanf(text_line,"%s \n",node_name) == 1){
			i++;
			*(*node_names_ptr + i) = strsave( node_name );
		}
		else{
			PRINT_LINE_DATA;
			printf("%s : unrecognized text\n",text_line);
			return ERROR;
		}
	}
	return(OK);
}

