/*
 * sens_ac_read takes the SPICE output file obtained from 
 * the system call 
 * and stores the infomation into two arrays.
 *
 */

extern int strcmp();
extern char *strsave();

#include <stdio.h>
#include <math.h>
#include "formulate.h"
#include "macros.h"

#define MAX_ROW_NUM 1000
#define MAX_LINE_LENGTH 200
#define PRINT_LINE_DATA {printf("%s: line %d\n",text_file_name,linenum);}
#define name1   *(node_names + node1_index)
#define name2   *(node_names + node2_index)

int sens_ac_read(text_file_name,node_names,frequency_point,
node1_index_list,node2_index_list,max_num_params,num_mag_ptr,num_ph_ptr,
sim_data,out_mode)

char *text_file_name;		/* The input text file			*/
char **node_names;
double frequency_point;
int *node1_index_list;
int *node2_index_list;
int max_num_params;
int *num_mag_ptr;
int *num_ph_ptr;
SIM_data sim_data;
int out_mode;

{
    FILE *text_file;
    FILE *mag_file;
    FILE *ph_file;
    char text_line[MAX_LINE_LENGTH];
    char filename[50];
    char *next_entry;
    char *begin_ptr;
    int	 linenum = 1;
    int	blank_linenum = 1;
    int number;
    int sens_type = REAL1;
    int first_line = YES;
    int blank;
    int i;
    float sens;
    double value;
    char dummy[10];
    int param_num = 0;
    int node1_index = 0;
    int node2_index = 0;
    int read_sens = NO;
    int line_num;
    int mag_entries = 0;
    int ph_entries = 0;
    int frequency_index;
    double sr1;
    double sr2;
    double si1;
    double si2;
    double sr;
    double si;
    double sm;
    double sp;
    double vr;
    double vi;
    double vm;
    double vp;
	double abs_vf;
	double abs_f;

    /*** add row_index, col_index ***/
    int row_index;
    int col_index;

    sprintf(filename,"%s_%d","/tmp/parcar.outfile1",getpid()); 
    mag_file = fopen(filename,"A");
    sprintf(filename,"%s_%d","/tmp/parcar.outfile2",getpid()); 
    ph_file = fopen(filename,"A");
    /* read input data and set up the data structures */

    /* Open the text file */
    if( (text_file = fopen(text_file_name,"r")) == NULL) {
	printf("\nE: \"%s\" file not found.\n",text_file_name);
	return ERROR;
    }

    /* Read file, line by line */
    for(line_num = 1; ;line_num++) {
	if(fgets(text_line,MAX_LINE_LENGTH,text_file) == NULL)
        break;
    
	/* Check for comment or empty line */
	if(text_line[0] == ';') continue;
	if(strlen(text_line) == 1) continue;

	if(sscanf(text_line,"Index %s",dummy) == 1){
	    if(fgets(text_line,MAX_LINE_LENGTH,text_file) == NULL){
                printf("sens_tran_ac 79: \
			no sensitivity info present \n");
			break;
	    }
        for(i=0; i<=MAX_LINE_LENGTH-1; i++){
		/* checking '-' line */
		if((text_line[i]==' ') ||
			(text_line[i]=='-')){
			continue;
	        }
		    else if (text_line[i]=='\n') break;
		    else {
		    printf("something wrong in output format");
			exit(-1);
		    }
	        }
next_frequency_point:

            if(fgets(text_line,MAX_LINE_LENGTH,text_file) == NULL){
			/*
	        printf("sens_tran_ac 98: \
			no sensitivity info present \n");
			*/
			break;
            }

	    begin_ptr = text_line;

	    number = FIRST;
	    read_sens = NO;
	    for(;;){
		if (*begin_ptr=='\n'){
		goto next_frequency_point;
 	        }
		if (*begin_ptr==' '){
		    begin_ptr++;
		    continue;
		}
		if (*begin_ptr==','){
		    begin_ptr++;
	 	    continue;
		}
		/* check if the next entry is a number (positive 
			or negative) or something else 
		    (go to next line if it is something else)*/

		    if(((*begin_ptr > '9') || (*begin_ptr < '0'))&&
					((*begin_ptr != '-')||
		    (*(begin_ptr+1) > '9') || (*(begin_ptr+1) < '0')))
			goto next_frequency_point;

		    value = atof(begin_ptr);
		    /* first three entries are index and complex frequency */
		    if(number == FIRST) {
		        number = SECOND;
		    }
		    else if(number == SECOND) {
			    number = THIRD;
    			abs_vf=FABS(value-frequency_point);
    			abs_f=FABS(frequency_point);
    			if(abs_vf < 0.001*abs_f){
    		    	/* correct frequency point */
    			    read_sens = YES;
    		    }
    		    else{
    			    goto next_frequency_point;
    		    }
		    }
		    else if(number == THIRD) {
    			number = FOURTH;
		    }
		    else if (read_sens == YES){

			    if((sens_type == REAL1) && (out_mode == OUT1_ZERO)){ 
					sr1 = 0;
					si1 = 0;
			        sens_type == REAL2;
				}

    	        if(sens_type == REAL1) {
    
    				/* real part for node1 */
    
    				sr1 = 1e-15*value;	

    			    sens_type = IMAG1;
    			    goto next_line;
    		    }
    		    else if(sens_type == IMAG1) {
    
    			    /* imaginary part for node1 */
    
    				si1 = 1e-15*value;
    
    				if(out_mode == OUT2_ZERO) {
						sens_type = REAL1; 
						sr2 = 0;
						si2 = 0;
						goto calculate;
					}
    				else sens_type = REAL2;
    				goto next_line;
    		    }
    	        else if(sens_type == REAL2) {
    
    				/* real part for node2 */
    
    				sr2 = 1e-15*value;	

    			    sens_type = IMAG2;
    			    goto next_line;
    		    }
    		    else if(sens_type == IMAG2) {
    
    				/* real part for node2 */
    
    				si2 = 1e-15*value;
    
calculate:			sr = sr1 - sr2;
    				si = si1 - si2;

			        param_num++ ;
    			    node1_index 
    				= *(node1_index_list + param_num);
    			    node2_index 
    				= *(node2_index_list + param_num);

    				frequency_index 
    					= findfreqindex(&sim_data,frequency_point);
    
    				vm = sim_data.waveform1[frequency_index];
    				vp = sim_data.waveform2[frequency_index];
    				vr = vm * cos(3.1415*vp/180);
    				vi = vm * sin(3.1415*vp/180);
    				sm = (vr*sr + vi*si)/vm;
    				sp = (vr*si - vi*sr)/vm*vm;
    
    				pvmpc_data[node1_index][node2_index] = sm;
    				pvppc_data[node1_index][node2_index] = 180*sp/3.1415;

    				mag_entries += 1;
    				ph_entries += 1;
    			    fprintf(mag_file,"name1 %s name2 %s %g \n",
    					(name1),(name2),sm);
    			    fprintf(mag_file,"node1_index %d node2_index %d\n",
    					node1_index,node2_index);
    			    fprintf(mag_file,"vr %g vi %g vm %g vp %g sr %g si %g\n\n"
					    ,vr,vi,vm,vp,sr,si);
    			    fprintf(ph_file,"name1 %s name2 %s %g \n",
    					(name1),(name2),sp);
    			    fprintf(ph_file,"node1_index %d node2_index %d \n",
    					node1_index,node2_index);
    			    fprintf(ph_file,"vr %g vi %g vm %g vp %g sr %g si %g\n\n",
    					vr,vi,vm,vp,sr,si);
    				sens_type = REAL1;
    		        goto next_line;
    		   }
    		   else{
    		       printf("sens_read.c: program error,\
        	       unknown sens_type\n");
			       return(ERROR);
		       }
	      }
	      else{
		      printf("sens_read.c: program error,\
		      unknown number\n");
		      return(ERROR);
	      }
	      for(next_entry = begin_ptr; ;next_entry++){
		  if (*next_entry == '\t')  break;
		  if (*next_entry == '\n'){
		  goto next_line;
	           }
	      }
	      begin_ptr = next_entry + 1;
	   }
       }
next_line: ;
    }
    *num_mag_ptr += mag_entries;
    *num_ph_ptr += ph_entries;
    fclose(mag_file);
    fclose(ph_file);
   return(OK);
}


