/*
 * Spice output types:
 */
#define	MAG			0 	/* ac magnitude */
#define PHASE			1	/* ac phase */
#define REAL1			2	/* ac phase */
#define REAL2			3	/* ac phase */
#define IMAG1			4	/* ac phase */
#define IMAG2			5	/* ac phase */




/*
 * Data MAX constants:
 */
#define MAX_INCARDS		10	/* maximum number of label types */
#define MAX_SPICE_PTS		1000	/* maximum number of spice pts. from
					   a simulation */
#define MAX_INLINE		64	/* maximum number of characters in an
					   input line */
#define MAX_NODES		100	/* maximum number of nodes in a 
					   spice ckt. */
#define PAIR			2	/* pair of nodes */







typedef struct incard		{
   	char *label;
	char *spiceinf;
} INCARD;

INCARD *Incards;




typedef struct sim_data 	{
	int len;
	double scale[1000];
	double waveform1[1000];
	double waveform2[1000];
} SIM_data;


typedef struct grad_card 	{
	char		node1[30];
	char		node2[30];
	double		grad;
} GRAD_card;

typedef struct grad_info	{
	char		label[MAX_INLINE];
	int		num_grads;
        GRAD_card	grad_card[MAX_NODES*MAX_NODES];
} GRAD_info;

GRAD_info *Gradients;
char sim_name[80]; /* simulator name */ 



double pvmpc_data[MAX_NODES][MAX_NODES];
double pvppc_data[MAX_NODES][MAX_NODES];
