/*		HEADER FOR MACROS
*		-----------------
*
*   File:	macros.h
*	Author:	Umakanta Choudhury
*   Date:	27th July 1989.
*
*/




#define ERROR -1
#define OK 0

#define MET1 1
#define MET2 2

#define YES 1
#define NO 0

#define SENS 0
#define FIRST 1
#define SECOND 2
#define THIRD 3
#define FOURTH 4
#define FIFTH 5

#define DC 1
#define AC 2
#define TRAN 3

#define OUT1_ZERO 1
#define OUT2_ZERO 2
#define NORMAL 3

#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b) (((a)>(b))?(a):(b))
#endif

#define MIN3(a,b,c) MIN( (MIN((a),(b))) , (c) )
#define MAX3(a,b,c) MAX( (MAX((a),(b))) , (c) )

/* Intersect - Evaluates TRUE if the (closed) intervals [l1,r1] and [l2,r2]
   intersect. Evaluates FALSE otherwise. */
#ifndef INTERSECT
#define INTERSECT(l1,r1,l2,r2) (((l1)>(r2))? FALSE : ((l2)>(r1))? FALSE: TRUE)
#endif

#define MALLOC(x) (( x *)malloc(sizeof(x)))
#define MNALLOC(n,x) (( x *)malloc(n*sizeof(x)))

#define FABS(x) ((x)>0.0)?(x):(-(x))

#define ADDFRONT(link,first_link) \
{(link)->prev = NULL; (link)->next = (first_link); \
if((first_link) != NULL) (first_link)->prev = (link); \
(first_link) = (link);}

#define print_error(X) {printf(X); return ERROR;}


