#include "sim2facet.h"
optionStruct optionList[] = {
    { "T",     "technology", "name of the technology ( \"schematic\" default )"}, 
    { OPT_RARG, "cell:view", "cell and view of the palette"},
    { 0, 	0,	0}};

s_options Options;
s_cells Cells;
octObject oPalette;
char *DefaultTechnology;
octObject oSimFacet;	/* not used, stubbed out so defaults work	*/
octObject oContentsFacet; /* not used, stubbed out so defaults work	*/
octObject oInterfaceFacet; /* not used, stubbed out so defaults work	*/

/*
 * createPalette
 *
 * a program which creates the palette for the PLA generator Octopus
 */

main( argc, argv )
int argc;
char **argv;
{
    setCellNames();
    initDefaults();
    parseComLine(argc, argv);
    setDefaults();

    openPalette();
    createInstances();

    OH_ASSERT( octFlushFacet( &oPalette));

    exit( 0 );
}

parseComLine( argc, argv )
int argc;
char **argv;
{
    extern char *optarg;
    int option;

    if( argc == 1 ){
	optUsage();
	exit(1);
    }
    /* so defaults.c code will run					*/
    Options.contentsFacetName = "dummy";
    while((option = optGetOption( argc, argv )) != EOF ){
	switch( option ) {
	    case 'T':
		Options.technology = util_strsav( optarg );
		break;
	    default:
		optUsage();
		break;
	}
    }
    Options.paletteName = argv[ optind ];
}


openPalette()
{
    octObject oProp;

    oPalette.type = OCT_FACET;
    oPalette.contents.facet.view = "symbolic";
    oPalette.contents.facet.facet = "contents";
    oPalette.contents.facet.mode = "w";
    oPalette.contents.facet.version = OCT_CURRENT_VERSION;

    OH_ASSERT( ohUnpackFacetName( &oPalette, Options.paletteName ));
    if ( octOpenFacet( &oPalette ) < OCT_OK ){
	errRaise( optProgName, -1,
	"Could not open facet %s:%s:%s: %s\n",
	oPalette.contents.facet.cell,
	oPalette.contents.facet.view,
	oPalette.contents.facet.facet,
	octErrorString());
    }
    OH_ASSERT( ohCreatePropStr( &oPalette, &oProp, 
				 "TECHNOLOGY", Options.technology ));
    OH_ASSERT( ohCreatePropStr( &oPalette, &oProp, "VIEWTYPE", "symbolic" ));
    OH_ASSERT( ohCreatePropStr( &oPalette, &oProp, "EDITSTYLE", "symbolic" ));
}

createInstances()
{
    octObject oInstBag;
    octObject oCell;

    OH_ASSERT( ohGetOrCreateBag( &oPalette, &oInstBag, "INSTANCES" ));

    OH_ASSERT( ohCreateInstance( &oPalette, &oCell, 
		      Cells.nchanFet.name, Cells.nchanFet.master, 
		      Cells.nchanFet.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( octAttach( &oInstBag, &oCell ));

    OH_ASSERT( ohCreateInstance( &oPalette, &oCell, 
		      Cells.pchanFet.name, Cells.pchanFet.master, 
		      Cells.pchanFet.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( octAttach( &oInstBag, &oCell ));

    OH_ASSERT( ohCreateInstance( &oPalette, &oCell, 
		      Cells.capacitor.name, Cells.capacitor.master, 
		      Cells.capacitor.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( octAttach( &oInstBag, &oCell ));

/*** install later
    OH_ASSERT( ohCreateInstance( &oPalette, &oCell, 
		      Cells.nenhFet.name, Cells.nenhFet.master, 
		      Cells.nenhFet.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( octAttach( &oInstBag, &oCell ));

    OH_ASSERT( ohCreateInstance( &oPalette, &oCell, 
		      Cells.ndepFet.name, Cells.ndepFet.master, 
		      Cells.ndepFet.view, 0, 0, OCT_NO_TRANSFORM ));
    OH_ASSERT( octAttach( &oInstBag, &oCell ));
*/

}
