/*
 * parse commmand line and set values in options structure.
 */


#include "sim2facet.h"

optionStruct optionList[] = {
    { "s",      "file", "name of input sim file"},
    { "f",      "facet[:version]", "name of output facet"},
    { "p",      "cell[:view]", "name of palette"},
    { "T",      "technology", "name of technology to use"},
    { OPT_RARG, "cell[:view]", "name of input cell"},
    { OPT_DESC, 0,"translate a .sim text file into an Oct facet"},
    { 0,        0,               0}
};

/* global variables set by the command line				*/

extern s_options Options;

/*
 * parseComLine
 *
 * parse the command line 
 */
parseComLine( argc, argv )
int argc;
char **argv;
{

    extern char	*optarg;
    int		option;

    while(( option = optGetOption( argc,argv)) != EOF ){
	switch ( option ) {
	    case 'f':
		Options.simFacetName = util_strsav( optarg );
		break;
	    case 's':
		Options.simFileName = util_strsav (optarg );
		break;
	    case 'p':
		Options.paletteName = util_strsav (optarg );
		break;
	    case 'T':
		Options.technology = util_strsav (optarg );
		break;
	    default:
		optUsage();
		break;
	}
    }
    if( argc == 1 ){
	optUsage();
	(void) exit(-1);
    }
    Options.contentsFacetName = util_strsav (argv[ optind ] );
}
