/*
 * sim2oct.c
 *
 * main routine for sim2oct.
 */

#include "sim2facet.h"

#ifndef CUR_DATE
#define CUR_DATE "sometime"
#endif

#ifndef VERSION
#define VERSION "1.0"
#endif

/* Global Variables							*/
octObject oContentsFacet;
octObject oInterfaceFacet;
octObject oSimFacet;
octObject oPalette;
s_options Options;
s_cells Cells;
char *DefaultTechnology;

/* import from the options package					*/
extern char *optProgName;

main( argc, argv)
int argc;
char *argv[];
{
    int result; /* sucessfule parse?					*/

    /* set up defaults 							*/
    initDefaults();

    /* parse command line						*/
    parseComLine( argc, argv);

    /* try to set up any unspecified option values			*/
    setDefaults();

    /* print version info						*/
    fprintf(stderr,"%s: version %s, compiled %s\n", optProgName,
		VERSION, CUR_DATE);

    octBegin();

    /* open the contents and sim facets and initilize other oct things	*/
    initFacets();

    /* translate the .sim file						*/
    result = simToOct();

    /* was the parse error free?					*/
    if( !result) {
	errRaise( optProgName, -1,
		"There were errors: %s was not created",
		ohFormatName( &oSimFacet));
    }

    /* do net and terminal attaching					*/
    attachFormals();

    OH_ASSERT( octFlushFacet( &oSimFacet));

    octEnd();

    exit(0);
}
