/*
 * sim2oct.h
 *
 * header file for sim2oct
 */


/* general include files						*/
#include "port.h"
#include "oct.h"
#include "oh.h"
#include "utility.h"
#include "options.h"
#include "errtrap.h"

#define TRUE 1
#define FALSE 0

typedef struct options {
    char	*simFileName;
    char	*simFacetName;
    char	*contentsFacetName;
    char	*paletteName;
    char	*technology;
} s_options;

typedef struct cellDesc {
    char *name;
    char *master;
    char *view;
} s_cellDesc;

typedef struct cells {
    s_cellDesc nchanFet;
    s_cellDesc pchanFet;
    s_cellDesc nenhFet;
    s_cellDesc ndepFet;
    s_cellDesc capacitor;
} s_cells;

typedef enum fetTermType { SOURCE, GATE, DRAIN } fetTermType;

typedef enum fetType { NCHAN, PCHAN, NENH, NDEP } fetType;

typedef enum dirType { DIR_IN, DIR_OUT, DIR_UNDEF } dirType;

typedef struct simFet{
    fetType type;
    float length, width;
    float xloc, yloc;
    char *source, *gate, *drain;
    dirType sourceDir, drainDir;
    char *modelName;
} s_simFet;

typedef struct simCapacitor{
    char *node1, *node2;
    float cap;
} s_simCapacitor;

typedef struct simNodeCap{
    char *node;
    float da, dp, pa, pp, ma, mp;
} s_simNodeCap;

typedef struct simNodeRes{
    char *node;
    float res;
} s_simNodeRes;
