

/* Option value structure */
typedef struct opt_vals_defn {
    /* Flags */
    unsigned contents_size:1;	/* Take size from contents */
    unsigned silent:1;		/* No warnings             */
    unsigned kill_contents:1;	/* Force write over contents */

    /* Set flags */
    unsigned left_s:1;		/* Left terminals set    */
    unsigned right_s:1;		/* Right terminals set   */
    unsigned top_s:1;		/* Top terminals set     */
    unsigned bottom_s:1;	/* Bottom terminals set  */
    unsigned name_s:1;		/* Name is set           */
    unsigned lambda_s:1;	/* Lambda value set      */
    unsigned width_s:1;		/* Width is set          */
    unsigned width_oct:1;	/* Width is oct not lambda */
    unsigned height_s:1;	/* Height is set         */
    unsigned height_oct:1;	/* Height is oct not lambda */
    unsigned stem_s:1;		/* Stem is set           */
    unsigned stem_oct:1;	/* Stem is oct not lambda */
    unsigned space_s:1;		/* Stem interval set      */
    unsigned space_oct:1;	/* Interval is oct not lambda */

    /* Actual values */
    char *desc_file;		/* Description file      */
    char *cell_spec;		/* Cell specification    */

    char *left;			/* Left side terminals   */
    char *right;		/* Right side terminals  */
    char *top;			/* Top side terminals    */
    char *bottom;		/* Bottom side terminals */

    char *name;			/* Symbol name           */
    octCoord lambda;		/* Units per lambda      */
    octCoord width;		/* Width (oct units)     */
    octCoord height;		/* Height (oct units)    */
    octCoord stem;		/* Stem size (lambda)    */
    octCoord space;		/* Stem interval (lambda) */
} opt_vals;


