/*
 * Readvals
 *
 * David Harrison
 * University of California, Berkeley
 * 1989
 *
 * This is a small package for reading name/value pairs from
 * a text file.  The format of the file is name, an equals symbol, 
 * followed by a value.  If either the name or the value includes
 * spaces,  it can be enclosed in double quotes.  For example:
 *
 * name = foobar 
 * "border color" = red
 * long = "this is a value that contains spaces"
 *
 * The values are retrieved by name.
 */

#ifndef READVALS_INCLUDED
#define READVALS_INCLUDED

#include <stdio.h>
#include "ansi.h"

typedef struct vals_dummy_defn {
    int dummy;
} vals_dummy;

typedef vals_dummy *val_db;

val_db vl_new ARGS((FILE *data_file, int (*cmp)()));
  /* Reads `data_file' and returns an appropriate database for it */

char *vl_query ARGS((val_db db, char *name));
  /* Querys database for `name' using `cmp' as comparison function */

void vl_delete ARGS((val_db db));
  /* Reclaims resources consumed by `db'. */

#endif /* READVALS_INCLUDED */
