/*
 * ANSI Compiler Support
 *
 * David Harrison
 * University of California, Berkeley
 * 1988
 *
 * ANSI compatible compilers are supposed to define the preprocessor
 * directive __STDC__.  Based on this directive, this file defines
 * certain ANSI specific macros.
 *
 * ARGS:
 *   Used in function prototypes.  Example:
 *   extern int foo
 *     ARGS((char *blah, double threshold));
 * VOID_R:
 *   (void) as a return value.  Example:
 *   extern VOID_R foo();
 * VOID_S:
 *   (void *) as a parameter or declaration.  Example:
 *   int foo(a)
 *   VOID_S a;
 */

/* Function prototypes */
#ifdef __STDC__
#define ARGS(args)	args
#define VOID_R		void
#define VOID_S		void*
#else
#define ARGS(args)	()
#define VOID_R
#define VOID_S		char*
#endif

