/*
 * VEM Cursor Management
 *
 * David Harrison
 * University of California,  Berkeley
 * 1987, 1989
 *
 * Definitions for using cursors routines defined in cursors.c
 */

#ifndef CURSOR_H
#define CURSOR_H

#include "ansi.h"
#include "general.h"
#include "X11/Xlib.h"

/* VEM cursor definitions */

#define	CONSOLE_CURSOR	0
#define CROSS_CURSOR	1
#define BUSY_CURSOR	2
#define GRAB_CURSOR	3
#define END_CURSORS	4

extern Cursor vemCursor
  ARGS((int curName));
   /* Returns one of the named cursors above */

extern void vemBusyWindow
  ARGS((Window win));
   /* Adds the specified window to the list of windows that may be busy */

extern void vemBusy();
   /* Sets the cursors to busy state */

extern void vemNotBusy();
   /* Sets the cursors to not busy */

#endif /* CURSOR_H */
