/*
 * Error Package
 */

#ifndef _VEM_ERR_H_
#define _VEM_ERR_H_

#include "ansi.h"
#include "general.h"
#include "X11/Xlib.h"
#include "errtrap.h"

extern int vemFail
  ARGS((char *name, char *filename, int line));
   /* Prints out classic yes, no, abort message */

extern int vemOctFail
  ARGS((char *filename, int line));
   /* Prints out oct assertion failure message */

extern int vemMultiFail
  ARGS((char *title, int numopts, char *options[], char *filename, int line));
   /* Prints out message,  offers user several options */

extern int vemXError
  ARGS((Display *theDisp, XErrorEvent *theError));
   /* Prints out X error message */

extern void vemXtError
  ARGS((char *msg));
  /* Prints out an Xt error message */

/*
 * Errtrap support
 */

void vemPushErrContext
  ARGS((jmp_buf env));
   /* Pushes setjmp environment */
void vemPopErrContext();
   /* Pops setjmp environment */
void vemDefaultTrapHandler
  ARGS((STR name, int code, STR message));
   /* Displays dialog with fatal message */

#endif /* _VEM_ERR_H_ */
