/*
 * Create command for symbolic
 *
 * David Harrison
 * University of California,  Berkeley
 * 1988, 1990
 *
 * This file dispatches to the appropriate create commands based on
 * the argument types found on the arg list.
 *
 * Work to be done:
 *  - becomes part of the vem specific symbolic commands
 *  - set up warning and merge functions
 */

#include "general.h"
#include "message.h"
#include "vemUtil.h"
#include "vulcan.h"



static void handler( type, msg )
    vulcanMessageType type;
    char* msg;
{
    char* head = "MSG";
    switch ( type ) {
    case VULCAN_INFORMATION:
	head = "INFO";
	break;
    case VULCAN_WARNING:
	head = "WARN";
	break;
    case VULCAN_SEVERE:
	head = "ERR";
	break;
    }
    vemMsg( MSG_C, "%s: %s", head, msg );
}

vemStatus interfaceCmd(spot, cmdList)
vemPoint *spot;			/* Where command was issued */
lsList cmdList;			/* Argument list            */
{
    octObject contents, interface;

    contents.objectId = spot->theFct;
    octGetById( &contents );
    interface = contents;
    interface.contents.facet.facet = "interface";
    interface.contents.facet.mode = "a";
    
    octOpenFacet( &interface );
    vemMsg( MSG_C, "Vulcan %s\n", ohFormatName( &contents ) );

    vulcanMessageHandler( handler );

    vulcan( &contents, &interface );

    return VEM_OK;
}


