/*
 * X Constants - Header definitions
 *
 * David Harrison
 * University of California, Berkeley
 * 1989
 *
 * Definitions for accessing X constants exported by xvals.c.
 */

#ifndef _XV_H_
#define _XV_H_

#include "ansi.h"
#include "port.h"
#include "X11/Xlib.h"
#include "X11/Intrinsic.h"

extern char *xv_pkg_name;

/* Fatal errors */
#define XV_MULTI_SET	-1	/* Value set twice */
#define XV_NOT_SET	-2	/* Value not set   */

/*
 * Getting values
 */

Display *xv_disp();
   /* Returns display connection */
int xv_scrn();
   /* Returns display screen */
Visual *xv_vis();
   /* Returns appropriate visual */
Colormap xv_cmap();
   /* Returns appropriate colormap */
Drawable xv_drw();
   /* Returns appropriate drawable */
int xv_depth();
   /* Returns appropriate depth */
Widget xv_topw();
   /* Returns top level shell widget */

/*
 * Setting values
 *
 * These values are set once by VEM initialization routines.
 */

void xv_set_disp
  ARGS((Display *disp));
void xv_set_scrn
  ARGS((int scrn));
void xv_set_vis
  ARGS((Visual *vis));
void xv_set_cmap
  ARGS((Colormap cmap));
void xv_set_drw
  ARGS((Drawable drw));
void xv_set_depth
  ARGS((int depth));
void xv_set_topw
  ARGS((Widget widget));

#endif /* _XV_H_ */
