
/* stolen from sys/types.h on 4.3 BSD */


#define	RPC_NBBY	8		/* number of bits in a byte */
/*
 * Select uses bit masks of file descriptors in longs.
 * These macros manipulate such bit fields (the filesystem macros use chars).
 * RPC_FD_SETSIZE may be defined by the user, but the default here
 * should be >= NOFILE (param.h).
 */
#ifndef	RPC_FD_SETSIZE
#define	RPC_FD_SETSIZE	256
#endif /* RPC_FD_SETSIZE */

typedef long	rpc_fd_mask;
#define RPC_NFDBITS	(sizeof(rpc_fd_mask) * RPC_NBBY)	/* bits per mask */
#ifndef rpc_howmany
#define	rpc_howmany(x, y)	(((x)+((y)-1))/(y))
#endif /* rpc_howmany */

typedef	struct rpc_fd_set {
	rpc_fd_mask	fds_bits[rpc_howmany(RPC_FD_SETSIZE, RPC_NFDBITS)];
} rpc_fd_set;

#define	RPC_FD_SET(n, p)	((p)->fds_bits[(n)/RPC_NFDBITS] |= (1 << ((n) % RPC_NFDBITS)))
#define	RPC_FD_CLR(n, p)	((p)->fds_bits[(n)/RPC_NFDBITS] &= ~(1 << ((n) % RPC_NFDBITS)))
#define	RPC_FD_ISSET(n, p)	((p)->fds_bits[(n)/RPC_NFDBITS] & (1 << ((n) % RPC_NFDBITS)))
#define RPC_FD_ZERO(p)	bzero((char *)(p), sizeof(*(p)))

extern void RPC_FD_AND();
extern void RPC_FD_OR();
extern void RPC_FD_OR_3();
extern void RPC_FD_NOT();
extern int RPC_FD_ALL_ZERO();
extern int RPC_FD_FIRST_SET();
extern int RPC_FD_FIRST_SET_AND();
extern int RPC_FD_ANY_COMMON_BITS();
