/*
 * Schematic Move and Copy
 *
 * David Harrison
 * University of California, Berkeley
 * 1990
 *
 * This is an interface built on top of symbolic for schematic
 * move and copy.
 */

#include "general.h"
#include "oct.h"
#include "commands.h"
#include "se.h"

vemStatus schemMove(spot, cmdList)
vemPoint *spot;			/* Where command was issued */
lsList cmdList;			/* Argument list            */
/*
 * This routine uses the symbolic move and copy except no
 * reconnects are ever done.
 */
{
    return seBaseMove(spot, cmdList, 0);
}

vemStatus schemCopy(spot, cmdList)
vemPoint *spot;			/* Where command was issued */
lsList cmdList;			/* Argument list            */
/*
 * This routine uses the symbolic copy and copy except no
 * reconnects are ever done.
 */
{
    return seBaseCopy(spot, cmdList, 0, symDefConFunc);
}
