/*
 * VEM Selection Set Header File
 *
 * David Harrison
 * University of California,  Berkeley
 * 1986
 *
 * This file contains headers for the routines implemented in
 * selset.c.  The following files should be included before
 * this one:
 *    oct.h
 */

#ifndef SELSET
#define SELSET

#include "oct.h"
#include "commands.h"

extern vemOneArg *vemAttrSelSet();
   /* Creates a new selected set with predefined attributes */
extern vemOneArg *vemNewSelSet();
   /* Creates a new selected set with some specified attributes */
extern int vemFreeAttrSet();
   /* Frees the selected set and returns predefined attributes */
extern int vemFreeSelSet();
   /* Frees the selected set AND any predefined attributes     */

extern int vemClearSelSet();
   /* Deselects all items in a specified selected set           */
extern int vemAddSelSet();
   /* Adds a specified OCT object to a selected set             */
extern int vemDelSelSet();
   /* Removes a specified OCT object from a selected set        */
extern int vemRCSelSet();
   /* Special routine which replaces an object in a set         */
extern int vemZoomSelSet();
   /* Zooms a specified window to contain only selected items    */

#endif
