/*
 * VEM Color Utilities
 *
 * David Harrison
 * University of California,  Berkeley
 * 1989
 *
 * This file contains some general purpose utilities for
 * dealing with color.
 */

#include "vemUtil.h"
#include "xvals.h"

unsigned long vuWhite(clr)
XColor *clr;			/* Returned color structure */
/*
 * Returns the white pixel for the display.  If `clr' is
 * non-zero,  it will return the full color structure
 * for the white pixel.
 */
{
    static XColor white;
    static int init = 0;

    if (!init) {
	white.pixel = WhitePixel(xv_disp(), xv_scrn());
	XQueryColor(xv_disp(), xv_cmap(), &white);
    }
    if (clr) *clr = white;
    return white.pixel;
}


unsigned long vuBlack(clr)
XColor *clr;			/* Returned color structure */
/*
 * Returns the black pixel for the display.  If `clr' is
 * non-zero,  it will return the full color structure
 * for the black pixel.
 */
{
    static XColor black;
    static int init = 0;

    if (!init) {
	black.pixel = BlackPixel(xv_disp(), xv_scrn());
	XQueryColor(xv_disp(), xv_cmap(), &black);
    }
    if (clr) *clr = black;
    return black.pixel;
}
