/*
 * Argument Selection Set Header
 *
 * David Harrison
 * University of California,  Berkeley
 * 1987, 1989
 *
 * This file contains header definitions for the argument list selection
 * module implemented in argsel.c.  This package exports an interface
 * for displaying argument types in all appropriate windows.
 *
 * IMPORTANT:  all routines assume that the selection attributes desired
 * have already been set by appropriate calls to the attribute module.
 */

#ifndef ARGSEL_HEADER
#define ARGSEL_HEADER

#include "ansi.h"
#include "commands.h"		/* Dispatch module */

extern void argOn
  ARGS((vemOneArg *arg));
  /* Turns on the selection of an argument */

extern void argOff
  ARGS((vemOneArg *arg));
  /* Turns off selection of an argument */

extern void argType
  ARGS((vemOneArg *arg, int type));
  /* Sets the type of the arg set */

extern void argAddPoint
  ARGS((vemOneArg *arg, vemPoint *pnt));
  /* Adds a point to the current set */

extern void argChgPoint
  ARGS((vemOneArg *arg, int idx, vemPoint *pnt));
  /* Changes an existing point */

extern vemStatus argDelPoint
  ARGS((vemOneArg *arg, int idx));
  /* Removes an existing point */

extern void argInsPoint
  ARGS((vemOneArg *arg, int idx, vemPoint *pnt));
  /* Inserts a new point */

#endif
