/* file name : yal2oct.c   */

/* yal2oct - translate cells in YAL format to oct format

   Copyright (C) 1987 by Jonathan Rose.  All rights reserved.
   Copyright (C) 1988 by Yoshihito Nishizaki.  All rights reserved.

*/

#include "copyright.h"
#include "port.h"
#include "benchtypes.h"

#define false 0
#define true  1

FILE *CheckOpen();


main(argc,argv) 

char *argv[];

{ 

    FILE *InputFile;

    NameType Name;
    ModuleType ModType;
    IOList *IOListHead;
    CoordPair *Dimensions;
    NetworkList *NetworkListHead;
    PlacementList *PlacementListHead;
    CriticalNetList *CriticalNetListHead;
    short Done;
    int ModuleNumber;


    if (argc < 2 ) {
	(void) printf("Usage: yal2oct inputfile\n");
	exit(-1);
    }


    /* Open input and output files */

    InputFile = CheckOpen(argv[1],"r");

    Done = false;
    for(ModuleNumber = 1; !Done; ModuleNumber++) {

	GetModule(InputFile, Name, &ModType, &Dimensions, &IOListHead, 
		  &NetworkListHead, &PlacementListHead, &CriticalNetListHead);
	
	if (ModType == ENDFILE) {
	    Done = true;
	} else {
	    (void) printf("Got Module %d\n",ModuleNumber);
	    WriteOct(Name, ModType, Dimensions, IOListHead, 
		      NetworkListHead, PlacementListHead,CriticalNetListHead);
	}
    }
    exit(0);
}


FILE *CheckOpen(FileName,OpenType)

char *FileName, *OpenType;

{
    FILE *FPointer;


    FPointer = fopen(FileName,OpenType);
    if (FPointer != NULL) return(FPointer);
    (void) printf("Cannot open file %s\n",FileName);
    exit(-1);
    /*NOTREACHED*/
}
